unit AspDataGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ExtCtrls, ComCtrls,
  MainForm, OptSurface,OptMedium;

type
  TAsphericalDataGrid = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    DataGrid: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    StringGrid5: TStringGrid;
    StringGrid6: TStringGrid;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    ComboBox2: TComboBox;
    Label16: TLabel;
    ComboBox1: TComboBox;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure DataGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid2SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid3SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid4SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid5SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid6SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FormCreate(Sender: TObject);
    procedure DataGridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure ComboBox2Change(Sender: TObject);
    procedure DataGridDblClick(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure DataGridKeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid2KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid3KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid4KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid5KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid6KeyPress(Sender: TObject; var Key: Char);
    procedure DataGridClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid2Click(Sender: TObject);
    procedure StringGrid3Click(Sender: TObject);
    procedure StringGrid4Click(Sender: TObject);
    procedure StringGrid5Click(Sender: TObject);
    procedure StringGrid6Click(Sender: TObject);
    procedure BitBtn9Click(Sender: TObject);
    procedure BitBtn10Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Draw;
    procedure DataFix;
    procedure HiAsBasicDraw;
    procedure YZDraw;
    procedure HiAsDataFix;
    procedure CylindDraw;
    procedure FresnelDraw;
    procedure CylindFix;
    procedure FresnelFix;

  public
    { Public 錾 }
    procedure RefreshDraw;
  end;

var
  AsphericalDataGrid: TAsphericalDataGrid;

implementation

uses ParAxialForm;

{$R *.dfm}



procedure TAsphericalDataGrid.CylindFix;
var row:integer;
begin

  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].CylinderFlag:=StrToInt(StringGrid5.Cells[1,row]);
  end;
  //'Zȗ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].CylinderCz:=StrToFloat(StringGrid5.Cells[2,row]);
  end;
  //'Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].CylinderAngle:=StrToFloat(StringGrid5.Cells[3,row]);
  end;

  //'œ_';
  OpticalSystem.FocusPlane.CylinderFlag:=StrToInt(StringGrid5.Cells[1,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.CylinderCz:=StrToFloat(StringGrid5.Cells[2,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.CylinderAngle:=StrToFloat(StringGrid5.Cells[3,OpticalSystem.TotalSurfaceNumber+1]);

end;

procedure TAsphericalDataGrid.FresnelFix;
var row:integer;
begin

  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].FrenelFlag:=StrToInt(StringGrid6.Cells[1,row]);
  end;
  //'0][';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].FrenelZeroZorn:=StrToFloat(StringGrid6.Cells[2,row]);
  end;
  //'sb`';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].FrenelPich:=StrToFloat(StringGrid6.Cells[3,row]);
  end;

end;

procedure TAsphericalDataGrid.CylindDraw;
var row:integer;
begin

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid5.Cells[0,row]:=IntToStr(row) + ' ';
  end;

  StringGrid5.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid5.Cells[1,row]:=IntToStr(OpticalSystem.OpticalSurface[row].CylinderFlag);
  end;
  StringGrid5.Cells[2,0]:='Zȗ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid5.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].CylinderCz);
  end;
  StringGrid5.Cells[3,0]:='Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid5.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].CylinderAngle);
  end;

  StringGrid5.Cells[0,OpticalSystem.TotalSurfaceNumber+1]:='œ_';
  StringGrid5.Cells[1,OpticalSystem.TotalSurfaceNumber+1]:=IntToStr(OpticalSystem.FocusPlane.CylinderFlag);
  StringGrid5.Cells[2,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.CylinderCz);
  StringGrid5.Cells[3,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.CylinderAngle);
  
end;

procedure TAsphericalDataGrid.FresnelDraw;
var row:integer;
begin

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid6.Cells[0,row]:=IntToStr(row) + ' ';
  end;

  StringGrid6.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid6.Cells[1,row]:=IntToStr(OpticalSystem.OpticalSurface[row].FrenelFlag );
  end;
  StringGrid6.Cells[2,0]:='0][';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid6.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].FrenelZeroZorn);
  end;
  StringGrid6.Cells[3,0]:='sb`';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid6.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].FrenelPich);
  end;

  self.Caption:='񋅖'+' /'+opticalSystem.OpticalName;
end;
 

procedure TAsphericalDataGrid.HiAsBasicDraw;
var row:integer;
begin

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[0,row]:=' '+ IntToStr(row) + ' ';
  end;

  StringGrid1.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    if(OpticalSystem.OpticalSurface[row].HiOrderSwitch =true) then begin
      StringGrid1.Cells[1,row]:='True';
    end else begin
      StringGrid1.Cells[1,row]:='False';
    end;
  end;

  StringGrid1.Cells[2,0]:='ǐՖ@';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[2,row]:=IntToStr(OpticalSystem.OpticalSurface[row].ApproxChangeFlag);
  end;

  StringGrid1.Cells[3,0]:='Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].HighOrderAngle);
  end;

  StringGrid1.Cells[4,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[4,row]:=IntToStr(OpticalSystem.OpticalSurface[row].HighOrderTerm);
  end;
end;

procedure TAsphericalDataGrid.YZDraw;
var row,i:integer;
begin

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid2.Cells[0,row]:=IntToStr(row) + ' ';
  end;
  for i:=1 to 8 do begin
    StringGrid2.Cells[i,0]:=IntToStr(i) + ' ';
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      StringGrid2.Cells[i,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].HighOrderPowerY[i]);
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid3.Cells[0,row]:=IntToStr(row) + ' ';
  end;
  for i:=1 to 8 do begin
    StringGrid3.Cells[i,0]:=IntToStr(i) + ' ';
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      StringGrid3.Cells[i,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].HighOrderPowerZ[i]);
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid4.Cells[0,row]:=IntToStr(row) + ' ';
  end;
  for i:=1 to 8 do begin
    StringGrid4.Cells[i,0]:=IntToStr(i) + ' ';
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      StringGrid4.Cells[i,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].HighOrderCoefficient[i]);
    end;
  end;


end;



procedure TAsphericalDataGrid.HiAsDataFix;
var row,i:integer;
begin
 //
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    if(StringGrid1.Cells[1,row]='true')or(StringGrid1.Cells[1,row]='True') then begin
      OpticalSystem.OpticalSurface[row].HiOrderSwitch:=True;
    end else begin
      OpticalSystem.OpticalSurface[row].HiOrderSwitch:=False;
    end;
  end;

 //'ǐՖ@'
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApproxChangeFlag:=StrToInt(StringGrid1.Cells[2,row]);
  end;

 //'X'
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].HighOrderAngle:=StrToFloat(StringGrid1.Cells[3,row]);
  end;

  //''
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].HighOrderTerm:=StrToInt(StringGrid1.Cells[4,row]);
  end;


  for i:=1 to 8 do begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      OpticalSystem.OpticalSurface[row].HighOrderPowerY[i]:=StrToFloat(StringGrid2.Cells[i,row]);
    end;
  end;


  for i:=1 to 8 do begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      OpticalSystem.OpticalSurface[row].HighOrderPowerZ[i]:=StrToFloat(StringGrid3.Cells[i,row]);
    end;
  end;

  for i:=1 to 8 do begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
      OpticalSystem.OpticalSurface[row].HighOrderCoefficient[i]:=StrToFloat(StringGrid4.Cells[i,row]);
    end;
  end;


end;
//******************Note1*********************

procedure TAsphericalDataGrid.Draw;
var row,i:integer;
begin

  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[0,row]:=' _';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[0,row]:=' œ_';
      end else begin
        DataGrid.Cells[0,row]:=' '+IntToStr(row-1)+'  ';
      end;
    end;
  end;

  DataGrid.Cells[1,0]:='~';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if(OpticalSystem.ObjectPlane.ConicSwitch=true) then begin
        DataGrid.Cells[1,row]:='True';
      end else begin
        DataGrid.Cells[1,row]:='False';
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if(OpticalSystem.FocusPlane.ConicSwitch=true) then begin
          DataGrid.Cells[1,row]:='True';
        end else begin
          DataGrid.Cells[1,row]:='False';
        end;
      end else begin
        if(OpticalSystem.OpticalSurface[row-1].ConicSwitch=true) then begin
          DataGrid.Cells[1,row]:='True';
        end else begin
          DataGrid.Cells[1,row]:='False';
        end;
      end;
    end;
  end;   

  DataGrid.Cells[2,0]:='~W';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[2,row]:=FloatToStr(OpticalSystem.ObjectPlane.ConicCoefficient);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[2,row]:=FloatToStr(OpticalSystem.FocusPlane.ConicCoefficient);
      end else begin
          DataGrid.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].ConicCoefficient);
      end;
    end;
  end;



  DataGrid.Cells[3,0]:='񋅖ʎ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[3,row]:=IntToStr(OpticalSystem.ObjectPlane.AspFlag);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[3,row]:=IntToStr(OpticalSystem.FocusPlane.AspFlag);
      end else begin
          DataGrid.Cells[3,row]:=IntToStr(OpticalSystem.OpticalSurface[row-1].AspFlag);
      end;
    end;
  end;


  DataGrid.Cells[4,0]:='ǐՖ@';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[4,row]:=IntToStr(OpticalSystem.ObjectPlane.ApproxChangeFlag);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[4,row]:=IntToStr(OpticalSystem.FocusPlane.ApproxChangeFlag);
      end else begin
          DataGrid.Cells[4,row]:=IntToStr(OpticalSystem.OpticalSurface[row-1].ApproxChangeFlag);
      end;
    end;
  end;

  DataGrid.Cells[5,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[5,row]:=IntToStr(OpticalSystem.ObjectPlane.AsphericalTerm);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[5,row]:=IntToStr(OpticalSystem.FocusPlane.AsphericalTerm);
      end else begin
          DataGrid.Cells[5,row]:=IntToStr(OpticalSystem.OpticalSurface[row-1].AsphericalTerm);
      end;
    end;
  end;

  for i:=1 to 8 do begin
    DataGrid.Cells[5+i,0]:='W '+ IntToStr(i);

    for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
      if row=1 then begin
        DataGrid.Cells[5+i,row]:=FloatToStr(OpticalSystem.ObjectPlane.AsphericalCoefficient[i]);
      end else begin
        if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
          DataGrid.Cells[5+i,row]:=FloatToStr(OpticalSystem.FocusPlane.AsphericalCoefficient[i]);
        end else begin
           DataGrid.Cells[5+i,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].AsphericalCoefficient[i]);
        end;
      end;
    end;

  end;

end;


procedure TAsphericalDataGrid.DataFix;
var row,i:integer;
begin

  //'񋅖ʔ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if((DataGrid.Cells[1,row]='True')or(DataGrid.Cells[1,row]='true')) then begin
        OpticalSystem.ObjectPlane.ConicSwitch:=true
      end else begin
        OpticalSystem.ObjectPlane.ConicSwitch:=false;
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if((DataGrid.Cells[1,row]='True')or(DataGrid.Cells[1,row]='true')) then begin
          OpticalSystem.FocusPlane.ConicSwitch:=true
        end else begin
          OpticalSystem.FocusPlane.ConicSwitch:=false;
        end;
      end else begin
        if((DataGrid.Cells[1,row]='True')or(DataGrid.Cells[1,row]='true')) then begin
          OpticalSystem.OpticalSurface[row-1].ConicSwitch:=true
        end else begin
          OpticalSystem.OpticalSurface[row-1].ConicSwitch:=false;
        end;
      end;
    end;
  end;   

//'~W';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin

        OpticalSystem.ObjectPlane.ConicCoefficient:=StrToFloat(DataGrid.Cells[2,row]);

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin

          OpticalSystem.FocusPlane.ConicCoefficient:=StrToFloat(DataGrid.Cells[2,row]);

      end else begin

          OpticalSystem.OpticalSurface[row-1].ConicCoefficient:=StrToFloat(DataGrid.Cells[2,row]);
        
      end;
    end;
  end;



  //'񋅖ʎ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      OpticalSystem.ObjectPlane.AspFlag:=StrToInt(DataGrid.Cells[3,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.AspFlag:=StrToInt(DataGrid.Cells[3,row]);
      end else begin
          OpticalSystem.OpticalSurface[row-1].AspFlag:=StrToInt(DataGrid.Cells[3,row]);
      end;
    end;
  end;


  //'ǐՖ@';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      OpticalSystem.ObjectPlane.ApproxChangeFlag:=StrToInt(DataGrid.Cells[4,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.ApproxChangeFlag:=StrToInt(DataGrid.Cells[4,row]);
      end else begin
          OpticalSystem.OpticalSurface[row-1].ApproxChangeFlag:=StrToInt(DataGrid.Cells[4,row]);
      end;
    end;
  end;

  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      OpticalSystem.ObjectPlane.AsphericalTerm:=StrToInt(DataGrid.Cells[5,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.AsphericalTerm:=StrToInt(DataGrid.Cells[5,row]);
      end else begin
          OpticalSystem.OpticalSurface[row-1].AsphericalTerm:=StrToInt(DataGrid.Cells[5,row]);
      end;
    end;
  end;

  // 'W '
  for i:=1 to 8 do begin

    for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
      if row=1 then begin
        OpticalSystem.ObjectPlane.AsphericalCoefficient[i]:=StrToFloat(DataGrid.Cells[5+i,row]);
      end else begin
        if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
          OpticalSystem.FocusPlane.AsphericalCoefficient[i]:=StrToFloat(DataGrid.Cells[5+i,row]);
        end else begin
          OpticalSystem.OpticalSurface[row-1].AsphericalCoefficient[i]:=StrToFloat(DataGrid.Cells[5+i,row]);
        end;
      end;
    end;

  end;

end;


 


procedure TAsphericalDataGrid.BitBtn1Click(Sender: TObject);
var col,row:integer;
begin
  DataGrid.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;

  for col:=0 to 13 do begin
    for row:=1 to 64+2 do begin
      DataGrid.Cells[col,row]:='';
    end;
  end;

  self.Draw;
end;


procedure TAsphericalDataGrid.BitBtn2Click(Sender: TObject);
begin
  self.DataFix;
  BitBtn1.Click;
  FormPOPS.DataIsChanged;
end;


procedure TAsphericalDataGrid.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  visible:=false;
end;

procedure TAsphericalDataGrid.BitBtn3Click(Sender: TObject);
var col,row:integer;
begin
  StringGrid1.Font.Color:=clBlack;
  StringGrid2.Font.Color:=clBlack;
  StringGrid3.Font.Color:=clBlack;
  StringGrid4.Font.Color:=clBlack;
  BitBtn4.Font.Color:=clBlack;

  for col:=0 to 5 do begin
    for row:=1 to 64+2 do begin
      StringGrid1.Cells[col,row]:='';
    end;
  end;
  HiAsBasicDraw;

  for col:=0 to 9 do begin
    for row:=1 to 64+2 do begin
      StringGrid2.Cells[col,row]:='';
      StringGrid3.Cells[col,row]:='';
      StringGrid4.Cells[col,row]:='';
    end;
  end;
  YZDraw;
end;


procedure TAsphericalDataGrid.BitBtn4Click(Sender: TObject);
begin
  HiAsDataFix;
  BitBtn8.Click;
  FormPOPS.DataIsChanged;
end;

procedure TAsphericalDataGrid.BitBtn5Click(Sender: TObject);
var col,row:integer;
begin
  StringGrid5.Font.Color:=clBlack;
  BitBtn6.Font.Color:=clBlack;

  for col:=0 to 3 do begin
    for row:=1 to 64+2 do begin
      StringGrid5.Cells[col,row]:='';
    end;
  end;
  CylindDraw;

end;


procedure TAsphericalDataGrid.BitBtn6Click(Sender: TObject);
begin
  CylindFix;

  BitBtn5.Click;

  FormPOPS.DataIsChanged;

end;


procedure TAsphericalDataGrid.BitBtn7Click(Sender: TObject);
var col,row:integer;
begin
  StringGrid6.Font.Color:=clBlack;
  BitBtn8.Font.Color:=clBlack;
  for col:=0 to 3 do begin
    for row:=1 to 64+2 do begin
      StringGrid6.Cells[col,row]:='';
    end;
  end;
  FresnelDraw;
end;


procedure TAsphericalDataGrid.BitBtn8Click(Sender: TObject);
begin
  FresnelFix;
  BitBtn7.Click;
  FormPOPS.DataIsChanged;

end;


procedure TAsphericalDataGrid.DataGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  DataGrid.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
  BitBtn9.Font.Color:=clRed;
  BitBtn10.Font.Color:=clRed;
end;

procedure TAsphericalDataGrid.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid1.Font.Color:=clNavy;
  BitBtn4.Font.Color:=clRed;

end;

procedure TAsphericalDataGrid.StringGrid2SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid2.Font.Color:=clNavy;
  BitBtn4.Font.Color:=clRed;

end;

procedure TAsphericalDataGrid.StringGrid3SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid3.Font.Color:=clNavy;
  BitBtn4.Font.Color:=clRed;

end;

procedure TAsphericalDataGrid.StringGrid4SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid4.Font.Color:=clNavy;
  BitBtn4.Font.Color:=clRed;

end;

procedure TAsphericalDataGrid.StringGrid5SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid5.Font.Color:=clNavy;
  BitBtn6.Font.Color:=clRed;
  
  BitBtn9.Font.Color:=clRed;
  BitBtn10.Font.Color:=clRed;
end;

procedure TAsphericalDataGrid.StringGrid6SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid6.Font.Color:=clNavy;
  BitBtn8.Font.Color:=clRed;

end;

procedure TAsphericalDataGrid.FormCreate(Sender: TObject);
begin

  DataGrid.DefaultRowHeight := ComboBox1.Height - DataGrid.GridLineWidth;
  StringGrid1.DefaultRowHeight := ComboBox2.Height - StringGrid1.GridLineWidth;

end;

procedure TAsphericalDataGrid.DataGridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := DataGrid.Cells[ACol, ARow];

  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox1.Handle, 0,
                 Rect.Left + DataGrid.Left + 1, Rect.Top + DataGrid.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(SetStr);
    ComboBox1.Show;
    Exit;
  end;

  if ComboBox1.Visible then
    ComboBox1.Visible := False;

  DataGrid.Canvas.FillRect(Rect);

  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);

  DrawText(DataGrid.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);

 }
end;



procedure TAsphericalDataGrid.ComboBox1Change(Sender: TObject);
begin
  with DataGrid do begin
    Cells[Col, Row] := ComboBox1.Text;
  end;
  DataGrid.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;


procedure TAsphericalDataGrid.FormShow(Sender: TObject);
begin
   ComboBox1.Visible := False;
   ComboBox2.Visible := False;

end;

procedure TAsphericalDataGrid.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := StringGrid1.Cells[ACol, ARow];
  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox2.Handle, 0,
                 Rect.Left + StringGrid1.Left + 1, Rect.Top + StringGrid1.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox2.ItemIndex := ComboBox2.Items.IndexOf(SetStr);
    ComboBox2.Show;
    Exit;
  end;
  if ComboBox2.Visible then
    ComboBox2.Visible := False;
  StringGrid1.Canvas.FillRect(Rect);
  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);
     DrawText(StringGrid1.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);
 }
end;


procedure TAsphericalDataGrid.ComboBox2Change(Sender: TObject);
begin
  with StringGrid1 do begin
    Cells[Col, Row] := ComboBox2.Text;
  end;

  StringGrid1.Font.Color:=clNavy;
  BitBtn4.Font.Color:=clRed;
end;

procedure TAsphericalDataGrid.DataGridDblClick(Sender: TObject);
begin
  if DataGrid.Col=1 then begin
    if DataGrid.Cells[ DataGrid.Col,DataGrid.Row]='False' then begin
      DataGrid.Cells[ DataGrid.Col,DataGrid.Row]:='True';
    end else begin
      DataGrid.Cells[ DataGrid.Col,DataGrid.Row]:='False';
    end;
    DataGrid.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end; 
end;

procedure TAsphericalDataGrid.StringGrid1DblClick(Sender: TObject);
begin
  if StringGrid1.Col=1 then begin
    if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='False' then begin
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='True';
    end else begin
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='False';
    end;
    StringGrid1.Font.Color:=clNavy;
    BitBtn4.Font.Color:=clRed;
  end;
  
end;

procedure TAsphericalDataGrid.RefreshDraw;
begin
  BitBtn1.Click;
  BitBtn3.Click;
  BitBtn5.Click;
  BitBtn7.Click;
end;

procedure TAsphericalDataGrid.DataGridKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.DataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid1KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.HiAsDataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid2KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.HiAsDataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid3KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.HiAsDataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid4KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.HiAsDataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid5KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.CylindFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.StringGrid6KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.FresnelFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TAsphericalDataGrid.DataGridClick(Sender: TObject);
begin
    self.DataFix;
    FormPOPS.DataIsChanged;
end;

procedure TAsphericalDataGrid.StringGrid1Click(Sender: TObject);
begin
    BitBtn4Click(Sender);
end;

procedure TAsphericalDataGrid.StringGrid2Click(Sender: TObject);
begin
  BitBtn4Click(Sender);
end;

procedure TAsphericalDataGrid.StringGrid3Click(Sender: TObject);
begin
  BitBtn4Click(Sender);
end;

procedure TAsphericalDataGrid.StringGrid4Click(Sender: TObject);
begin
  BitBtn4Click(Sender);
end;

procedure TAsphericalDataGrid.StringGrid5Click(Sender: TObject);
begin
    self.CylindFix;
    FormPOPS.DataIsChanged;
end;

procedure TAsphericalDataGrid.StringGrid6Click(Sender: TObject);
begin
  BitBtn8Click(Sender);
end;

procedure TAsphericalDataGrid.BitBtn9Click(Sender: TObject);
begin
  BitBtn2.Click;  
  ParAxialDataForm.BitBtn1.Click;

  DataGrid.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;
  BitBtn9.Font.Color:=clBlack;
  BitBtn10.Font.Color:=clBlack;
end;

procedure TAsphericalDataGrid.BitBtn10Click(Sender: TObject);
begin
  ParAxialDataForm.BitBtn1.Click;

  StringGrid5.Font.Color:=clBlack;
  BitBtn6.Font.Color:=clBlack;
  BitBtn9.Font.Color:=clBlack;
  BitBtn10.Font.Color:=clBlack;
end;

end.
