program POPS;

uses
  Forms,
  MainForm in 'MainForm.pas' {FormPOPS},
  OptSystem in 'OpticalClasses\OptSystem.pas',
  OptSurface in 'OpticalClasses\OptSurface.pas',
  OptMedium in 'OpticalClasses\OptMedium.pas',
  MayMath in 'OpticalClasses\MayMath.pas',
  Ray in 'OpticalClasses\Ray.pas',
  DataGrid in 'DataGrid.pas' {DataGridForm},
  MediumDataGrid in 'MediumDataGrid.pas' {MediumGridForm},
  AspDataGrid in 'AspDataGrid.pas' {AsphericalDataGrid},
  CoAxialGrid in 'CoAxialGrid.pas' {CoAxialForm},
  ApertureGrid in 'ApertureGrid.pas' {ApertureForm},
  ParAxialForm in 'ParAxialForm.pas' {ParAxialDataForm},
  Cofficient in 'Cofficient.pas' {CoefficientForm},
  CurveBrowser in 'CurveBrowser.pas' {CurveForm},
  SpotBrowser in 'SpotBrowser.pas' {SpotForm},
  LataralBrowser in 'LataralBrowser.pas' {LataralForm},
  Bending in 'Bending.pas' {BendingForm},
  Bending2 in 'Bending2.pas' {BendingForm2},
  PlanBrowser in 'PlanBrowser.pas' {PlanForm},
  D3VewBrowser in 'D3VewBrowser.pas' {D3Vew},
  ScalingBrowser in 'ScalingBrowser.pas' {ScalingForm},
  GlassData in 'GlassData.pas' {GlassDataForm},
  UnitedData in 'UnitedData.pas' {UnitedDataForm},
  MTF in 'MTF.pas' {MTFform},
  BendingAberCurve in 'BendingAberCurve.pas' {BendAbeForm},
  AutoCorrection in 'AutoCorrection.pas' {LSMForm},
  SpotCorrection in 'SpotCorrection.pas' {SPCForm};

{$R *.res}

begin
  Application.Initialize;
  Application.HelpFile := 'HELPPOPS.HLP';
  Application.CreateForm(TFormPOPS, FormPOPS);
  Application.CreateForm(TDataGridForm, DataGridForm);
  Application.CreateForm(TMediumGridForm, MediumGridForm);
  Application.CreateForm(TAsphericalDataGrid, AsphericalDataGrid);
  Application.CreateForm(TCoAxialForm, CoAxialForm);
  Application.CreateForm(TApertureForm, ApertureForm);
  Application.CreateForm(TParAxialDataForm, ParAxialDataForm);
  Application.CreateForm(TCoefficientForm, CoefficientForm);
  Application.CreateForm(TCurveForm, CurveForm);
  Application.CreateForm(TSpotForm, SpotForm);
  Application.CreateForm(TLataralForm, LataralForm);
  Application.CreateForm(TBendingForm, BendingForm);
  Application.CreateForm(TBendingForm2, BendingForm2);
  Application.CreateForm(TPlanForm, PlanForm);
  Application.CreateForm(TD3Vew, D3Vew);
  Application.CreateForm(TGlassDataForm, GlassDataForm);
  Application.CreateForm(TUnitedDataForm, UnitedDataForm);
  Application.CreateForm(TMTFform, MTFform);
  Application.CreateForm(TBendAbeForm, BendAbeForm);
  Application.CreateForm(TLSMForm, LSMForm);
  Application.CreateForm(TSPCForm, SPCForm);
  Application.Run;
end.
