unit SpotCorrection;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, ExtCtrls, Spin, StdCtrls
  ,OptSystem,MainForm,OptSurface,OptMedium;

type
  TQRArray=Array[0..14800,0..MaxOptSurface*2+1] of double;

  TSPCForm = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    SpinEdit2: TSpinEdit;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    Label5: TLabel;
    Edit5: TEdit;
    Edit6: TEdit;
    SpinButton5: TSpinButton;
    SpinButton6: TSpinButton;
    Label8: TLabel;
    Label9: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    SpinButton7: TSpinButton;
    SpinButton8: TSpinButton;
    SpinButton9: TSpinButton;
    SpinButton10: TSpinButton;
    SpinButton11: TSpinButton;
    SpinButton12: TSpinButton;
    SpinButton13: TSpinButton;
    Label17: TLabel;
    Label18: TLabel;
    Edit14: TEdit;
    Label19: TLabel;
    SpinButton14: TSpinButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Edit1: TEdit;
    SpinButton1: TSpinButton;
    Label3: TLabel;
    Label20: TLabel;
    SpinEdit3: TSpinEdit;
    Edit3: TEdit;
    SpinButton3: TSpinButton;
    Label7: TLabel;
    Label4: TLabel;
    Edit4: TEdit;
    SpinButton4: TSpinButton;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button3: TButton;
    Button6: TButton;
    Label21: TLabel;
    Label22: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    SpinButton2: TSpinButton;
    GroupBox3: TGroupBox;
    Label6: TLabel;
    SpinEdit1: TSpinEdit;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Initialize;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinButton4DownClick(Sender: TObject);
    procedure SpinButton4UpClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinButton5DownClick(Sender: TObject);
    procedure SpinButton5UpClick(Sender: TObject);
    procedure SpinButton6DownClick(Sender: TObject);
    procedure SpinButton6UpClick(Sender: TObject);
    procedure SpinButton7DownClick(Sender: TObject);
    procedure SpinButton7UpClick(Sender: TObject);
    procedure SpinButton8DownClick(Sender: TObject);
    procedure SpinButton8UpClick(Sender: TObject);
    procedure SpinButton9DownClick(Sender: TObject);
    procedure SpinButton9UpClick(Sender: TObject);
    procedure SpinButton10DownClick(Sender: TObject);
    procedure SpinButton10UpClick(Sender: TObject);
    procedure SpinButton11DownClick(Sender: TObject);
    procedure SpinButton11UpClick(Sender: TObject);
    procedure SpinButton12DownClick(Sender: TObject);
    procedure SpinButton12UpClick(Sender: TObject);
    procedure SpinButton13DownClick(Sender: TObject);
    procedure SpinButton13UpClick(Sender: TObject);
    procedure SpinButton14UpClick(Sender: TObject);
    procedure SpinButton14DownClick(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }
    CorrectedOptSys,OriginalOptBuckUp:TOptSystem;
    InputAngle:double;
    InputAngleDecimal:double;
    CurvetureRate,DistanceRate:double;
    DumpingFactor:double;
    PlusM:integer;
    SpotNumber:integer;
    TextList:array[0..9] of string;
    FlagVarg:boolean;
    DEltaSum:double;
    FLIncr:double;
    BFLIncr:double;

    Fixed: array[1..MaxOptSurface*2] of boolean;
    CurvetureIncr:array[1..MaxOptSurface*2] of double;
    DistanceIncr:array[1..MaxOptSurface*2] of double;

    OriginRayCheckJadg:array[1..5080] of boolean;
    RayCheckJadg :array[1..5080] of boolean;
    OriginSpotDiameter:Array[1..5080] of Extended;
    CorrectSpotDiameter:Array[1..5080] of extended;
    DeltaSPD:Array[1..5080] of extended;     //13*13*10*3=5070 + PlusM

    aLS:Array[1..5080,1..MaxOptSurface*2] of double;
    YLS:Array[1..5080] of double;
    TLS:Array[1..MaxOptSurface*2] of double;
    NewData:Array[1..MaxOptSurface*2] of double;
    XLS:Array[1..5080,1..MaxOptSurface*2] of double;
    SLS:Array[1..5080,1..MaxOptSurface*2] of double;


    DeltaFL,DeltaBFL:Array[0..MaxOptSurface*2] of double;
    DeltaFLC:Array[0..MaxOptSurface*2] of double;
    DeltaFLg:Array[0..MaxOptSurface*2] of double;
    DeltaSA:Array[0..MaxOptSurface*2] of double;
    DeltaSC:Array[0..MaxOptSurface*2] of double;
    DeltaMAS:Array[0..MaxOptSurface*2] of double;
    DeltaSAS:Array[0..MaxOptSurface*2] of double;
    DeltaDS: Array[0..MaxOptSurface*2] of double;

    SA: TSA;
    OSC: TOSC;
    MAS: TMAS;
    SAS: TSAS;
    DIS: TDIS;
    MAG: TMAG;

    Weight:array[0..9] of double;

    VarN:integer;
    EquM:integer;

    a:TQRArray;      //pqp
    q:TQRArray;
    r:TQRArray;
    b:array[0..5080] of double;
    c:array[0..5080] of double;
    s:double;
    n,m:integer;
    y:array[0..5080] of double;

    procedure DataDraw;
    procedure DeltaCurvetureSetting;
    procedure QR;
    procedure qr_decomposition(Var a:TQRArray;Var n:integer;Var m:integer ;
                               Var q:TQRArray;Var r:TQRArray);
    procedure gramm_schumidt(Var aTQRArray;Var n:integer; Var m:integer;Var q:TQRArray);
    procedure LSQ(Sender:TObject);
    procedure NewDataSettingCurveture(Sender:TObject);
    procedure DeltaDistanceSetting;
    procedure NewDataSettingDistance(Sender:TObject);
    procedure DeltaSetting;
    procedure NewDataSetting(Sender:TObject);

  public
    { Public 錾 }
  end;

var
  SPCForm: TSPCForm;

implementation

uses UnitedData, Bending2,SpotBrowser, AutoCorrection ;

{$R *.dfm}

procedure TSPCForm.Initialize;
var i:integer;
begin
  CorrectedOptSys:=TOptSystem.Create;
  CorrectedOptSys.Initialize;
  OriginalOptBuckUp:=TOptSystem.Create;
  OriginalOptBuckUp.Initialize;
  
  InputAngle:=0;
  InputAngleDecimal:=0;
  Edit3.Text:=FloatToStr(InputAngleDecimal);
  
  CurvetureRate:=0.000001;
  Edit1.Text:=FloatToStrF(CurvetureRate,ffGeneral,8,3);
  DistanceRate:=0.005;
  Edit2.Text:=FloatToStr(DistanceRate);

  FLIncr:=0;
  Edit5.Text:=FloatToStr(FlIncr);
  BFLIncr:=0;
  Edit6.Text:=FloatToStr(BFLIncr);

  DumpingFactor:=0;
  Edit4.Text:=FloatToStr(DumpingFactor);
  PlusM:=9;
  SpinEdit2.Value:=PlusM;

  TextList[0]:='X|bg_CO'+#13#10;

  TextList[1]:='X|bg_CO'+#13#10+'œ_'+#13#10;

  TextList[2]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10;

  TextList[3]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10;

  TextList[4]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10;

  TextList[5]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10+'ʎ'+#13#10;

  TextList[6]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10+'ʎ'+#13#10+'R}'+#13#10;

  TextList[7]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10+
               'ʎ'+#13#10+'R}'+#13#10+'WIiAX'+#13#10;

  TextList[8]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10+
               'ʎ'+#13#10+'R}'+#13#10+'WIiAX'+#13#10+'TW^AX'+#13#10;

  TextList[9]:='X|bg_CO'+#13#10+'œ_'+#13#10+'obNtH[JX'+#13#10+'FC'+#13#10+'F'+#13#10+
               'ʎ'+#13#10+'R}'+#13#10+'WIiAX'+#13#10+'TW^AX'+#13#10+'c'+#13#10;


  Memo1.Clear;
  Memo1.Text:=TextList[PlusM];

  for i:=0 to 9 do begin
    Weight[i]:=1;
  end;

  Edit7.Text:=FloatToStr(Weight[3]);
  Edit8.Text:=FloatToStr(Weight[4]);
  Edit9.Text:=FloatToStr(Weight[5]);
  Edit10.Text:=FloatToStr(Weight[6]);
  Edit11.Text:=FloatToStr(Weight[7]);
  Edit12.Text:=FloatToStr(Weight[8]);
  Edit13.Text:=FloatToStr(Weight[9]);

  Edit14.Text:=FloatToStr(Weight[0]);

  SpotNumber:=9;

  
end;




procedure TSPCForm.FormCreate(Sender: TObject);
begin
  self.Initialize;
end;

procedure TSPCForm.Button1Click(Sender: TObject);
begin
  if FlagVarg=True  then begin
     OriginalOptBuckUp.CopyFrom(OpticalSystem);
     FlagVarg:=False;
  end;

  CorrectedOptSys.CopyFrom(OpticalSystem) ;

  self.DataDraw;
end;

procedure TSPCForm.DataDraw;
var i:integer;
    aStr:String;
    RC,CC:integer;
    aColCount:integer;
begin
  aColCount:=SpotNumber*SpotNumber*OpticalSystem.TotalSpectruNumber*3;
  StringGrid1.ColCount:=aColCount;
  
  for RC := 0 to StringGrid1.RowCount - 1 do
    for CC := 0 to StringGrid1.ColCount - 1 do
      StringGrid1.Cells[CC,RC] := '';

  for i:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[1,i]:=FloatToStrF(OpticalSystem.OpticalSurface[i].Curvature,ffGeneral,5,3);
  end;

 { for i:=OpticalSystem.TotalSurfaceNumber+1 to OpticalSystem.TotalSurfaceNumber*2-1 do begin
    StringGrid1.Cells[1,i]:=FloatToStrF(OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber].Distance,ffGeneral,5,3);
  end; //ʊԊu
  }
  StringGrid1.Cells[1,0]:='ȗ';
  StringGrid1.Cells[2,0]:='Œ';

  for i:=1 to OpticalSystem.TotalSurfaceNumber*2-1 do begin
    if Fixed[i]=True then begin
       aStr:='FIX';
    end else begin
        aStr:='';
    end;
    StringGrid1.Cells[2,i]:=aStr;
  end;

 for i := 1 to OpticalSystem.TotalSurfaceNumber*2-1 do begin
    if i<=OpticalSystem.TotalSurfaceNumber then begin
      StringGrid1.Cells[ 0,i]:=IntToStr(i)+'@';
    end else begin
 //      StringGrid1.Cells[ 0,i]:=IntToStr(i-OpticalSystem.TotalSurfaceNumber )+'@Ԋu';
    end;
  end;

  self.Caption:='X|bgł̍œK'+'/'+OpticalSystem.OpticalName;

end;

procedure TSPCForm.StringGrid1DblClick(Sender: TObject);
begin
  if StringGrid1.Col=2 then begin
    if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='FIX' then begin
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='';
      Fixed[StringGrid1.Row]:=False;
    end else begin
   // StringGrid1.Canvas.Font.Color := clRed;
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='FIX';
      Fixed[StringGrid1.Row]:=True;
    end;
  end;
end;



procedure TSPCForm.Button2Click(Sender: TObject);
var aTimes:integer;
    i:integer;
begin

  aTimes:=SpinEdit1.Value;

  if RadioButton1.Checked=True then begin
    for i:=1 to aTimes do begin
      self.DeltaCurvetureSetting;
      self.LSQ(Sender);
      self.NewDataSettingCurveture(Sender);
    end;
  end;

  if RadioButton2.Checked=True then begin
    for i:=1 to aTimes do begin
      self.DeltaCurvetureSetting;
      self.QR;

    UnitedDataForm.BitBtn2Click(Sender);
    UnitedDataForm.BitBtn3Click(Sender);
    UnitedDataForm.BitBtn18Click(Sender);

    BendingForm2.Button1.Click;

    CorrectedOptSys.CopyFrom(OpticalSystem);

    MaxSpotNumber:=15;
    SpotForm.SpotButton2.Click;
     UnitedDataForm.BitBtn1Click(Sender);
    end;
  end;
end;

procedure TSPCForm.DeltaCurvetureSetting;
var i,k,ii:integer;
    c:TSpectru;
    aZ,aY:Extended;
    aCounter,aC2,aC3:integer;
    s: Integer;
    j:integer;
    ss,tt,p:double;
    na1,na,kp,n1:integer;
    temp:double;

    aPrincipalRay:integer;
    aRC,aCC:integer;
begin

  MaxSpotNumber:=9;
  SpotForm.CulSpot;
  aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

  DeltaSum:=0;
  for j:=1 to   OpticalSystem.TotalSurfaceNumber do begin
    if OpticalSystem.OpticalSurface[j].Curvature=0 then  begin
      CurvetureIncr[j]:=0;
      DeltaSum:=DeltaSum+CurvetureIncr[j];
    end else begin
      if Fixed[j]=true then begin
        CurvetureIncr[j]:=1e-20;          //0Z
        DeltaSum:=DeltaSum+CurvetureIncr[j];
      end else begin
        CurvetureIncr[j]:=CurvetureRate;
        DeltaSum:=DeltaSum+CurvetureIncr[j];
      end;
    end;
  end;




  aCounter:=0;
  aC2:=0;
  for i:=1 to 3 do  begin                                        //IWĩX|bgl 3
    for c:=nd to OpticalSystem.LastSpectru do begin
       for k:=1to MaxSpotNumber*MaxSpotNumber do begin

         if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
           aC2:=aC2+1;
          // OriginRayCheckJadg[aCounter]:=False;
         end else begin
           aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
           aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

           aCounter:=aCounter+1;
           OriginRayCheckJadg[aCounter]:=True;
           OriginSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
         end;

       end;
    end;
  end;



  DeltaFL[0]:=OpticalSystem.FocalLength[nd];
  DeltaBFL[0]:=OpticalSystem.BackFocus[nd];
  DeltaFLC[0]:=OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd];
  DeltaFLg[0]:=OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd];

  OpticalSystem.CalculateSphericalAberration(SA,OSC);
  OpticalSystem.CalculateAS(MAS,SAS,InputAngle);
  OpticalSystem.CalculateDistortion( DIS, InputAngle);

  DeltaSA[0]:=SA[nd,trunc(MaxSANumber*0.9)];
  DeltaSC[0]:=OSC[trunc(MaxSANumber*0.9)];
  DeltaMAS[0]:=MAS[MaxAngleNumber];
  DeltaSAS[0]:=SAS[MaxAngleNumber];
  DeltaDS[0]:=DIS[MaxAngleNumber];

  for s:=1 to OpticalSystem.TotalSurfaceNumber do begin


      if Fixed[s]=True then begin
        OpticalSystem.OpticalSurface[s].Curvature:=OpticalSystem.OpticalSurface[s].Curvature+CurvetureIncr[s];
      end else begin       //ȗω
        OpticalSystem.OpticalSurface[s].Curvature:=OpticalSystem.OpticalSurface[s].Curvature+CurvetureIncr[s];
      end;

      SpotForm.CulSpot;
      aCounter:=0;
      aC2:=0;
      for i:=1 to 3 do  begin
        for c:=nd to OpticalSystem.LastSpectru do begin
          for k:=1to MaxSpotNumber*MaxSpotNumber do begin

            if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
              aC2:=aC2+1;
             // RayCheckJadg[aCounter]:=False;

            end else begin
              aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
              aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

              aCounter:=aCounter+1;
              RayCheckJadg[aCounter]:=True;
              CorrectSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
              DeltaSPD[aCounter]:=CorrectSpotDiameter[aCounter]-OriginSpotDiameter[aCounter];
            end;

          end;
        end;
      end;




    aC3:=0;
    for ii:=1 to aCounter do begin
      if RayCheckJadg[ii]=True then begin
         aC3:=aC3+1;
         aLS[aC3,s]:=DeltaSPD[ii]*Weight[0];
      end;
    end;

    OpticalSystem.ParAxialTrace(FinalOpt) ;
    DeltaFL[s]:=OpticalSystem.FocalLength[nd]-DeltaFL[0];
    DeltaBFL[s]:=OpticalSystem.BackFocus[nd]-DeltaBFL[0];
    DeltaFLC[s]:=(OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd])-DeltaFLC[0];
    DeltaFLg[s]:=(OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd])-DeltaFLg[0];

    OpticalSystem.CalculateSphericalAberration(SA,OSC);
    opticalSystem.CalculateAS(MAS,SAS,InputAngle);
    OpticalSystem.CalculateDistortion( DIS, InputAngle);

    DeltaSA[s]:=SA[nd,trunc(MaxSANumber*0.9)]-DeltaSA[0];
    DeltaSC[s]:=OSC[trunc(MaxSANumber*0.9)]-DeltaSC[0];
    DeltaMAS[s]:=MAS[MaxAngleNumber]-DeltaMAS[0];
    DeltaSAS[s]:=SAS[MaxAngleNumber]-DeltaSAS[0];
    DEltaDS[s]:=DIS[MaxAngleNumber]-DeltaDS[0];

      aLS[aC3+1,s]:=DeltaFL[s];
      aLS[aC3+2,s]:=DeltaBFL[s] ;
      aLS[aC3+3,s]:=DeltaFLC[s]*Weight[3];
      aLS[aC3+4,s]:=DeltaFLg[s]*Weight[4];
      aLS[aC3+5,s]:=DeltaSA[s]*Weight[5];
      aLS[aC3+6,s]:=DeltaSC[s]*Weight[6];
      aLS[aC3+7,s]:=DeltaMAS[s]*Weight[7];
      aLS[aC3+8,s]:=DeltaSAS[s]*Weight[8];
      aLS[aC3+9,s]:=DeltaDS[s]*Weight[9];


    OpticalSystem.CopyFrom(CorrectedOptSys);
  end;



  VarN:=OpticalSystem.TotalsurfaceNumber;//OpticalSystem.TotalSurfaceNumber*2-1;
  EquM:=aC3+PlusM;


//////////////////////////////////////////////////////////////////////////////////

  for j:=1 to aC3 do begin
    YLS[j]:=-1 * (OriginSpotDiameter[j])*Weight[0];  //ڕWl
  end;
  YLS[aC3+1]:=FLIncr;
  YLS[aC3+2]:=BFLIncr;
  YLS[aC3+3]:=-1*DeltaFLC[0]*Weight[3];
  YLS[aC3+4]:=-1*DeltaFLg[0]*Weight[4];
  YLS[aC3+5]:=-1*DeltaSA[0]*Weight[5];
  YLS[aC3+6]:=-1*DeltaSC[0]*Weight[6];
  YLS[aC3+7]:=-1*DeltaMAS[0]*Weight[7];
  YLS[aC3+8]:=-1*DeltaSAS[0]*Weight[8];
  YLS[aC3+9]:=-1*DeltaDS[0]*Weight[9];

  if CheckBox1.Checked=True then begin
    for aRC := 0 to StringGrid1.RowCount - 1 do
      for aCC := 0 to StringGrid1.ColCount - 1 do
        StringGrid1.Cells[aCC,aRC] := '';

    for j := 1 to VarN do begin
      for i := 1 to EquM do begin
        StringGrid1.Cells[ 0,j]:=IntToStr(j);
        StringGrid1.Cells[ i,0]:=IntToStr(i);
      end;
    end;

    for j := 1 to VarN do begin
      for i := 1 to EquM do begin
        StringGrid1.Cells[ i,j]:=FloatToStrF(aLS[i,j],ffgeneral,5,3);
      end;
    end;

    for i := 1 to EquM do begin
      StringGrid1.Cells[i,VarN+2]:=FloatToStrF(YLS[i],ffgeneral,5,3);
    end;
  end;

end;

procedure TSPCForm.QR;
var i,j :integer;
begin

  n:=EquM;     //3   pq͍ŏƋt
  m:=VarN;     //2 ʐ


//QR
  for i:=0 to m-1 do begin
    for j:=0 to n-1 do begin
      a[j,i]:=aLS[j+1,i+1];      //ǂݍ ;
    end;
  end;

  for j:=0 to n-1 do begin
    y[j]:=YLS[j+1] + DeltaSum*DumpingFactor;   //ω
  end;

  self.qr_decomposition(a,n,m,q,r);

  for j:=0 to m-1 do begin
    s:=0;
    for i:=0 to n-1 do begin
      s:=s+q[i,j] * (y[i] );   
    end;
    b[j]:=s ;
  end;

  for i:=m-1 downto 0 do begin
    c[i]:=b[i];
    for j:=m-1 downto i+1 do begin
      c[i]:=c[i]-r[i,j]*c[j];
    end;
    c[i]:=c[i]/r[i,i];
  end;


  for i:=0 to m-1 do begin
    if i<=OpticalSystem.TotalSurfaceNumber-1 then begin
      if Fixed[i+1]=True then begin
        OpticalSystem.OpticalSurface[i+1].curvature:= OpticalSystem.OpticalSurface[i+1].curvature+0;
      end else begin
        NewData[i+1]:=c[i]*CurvetureIncr[i+1]+OpticalSystem.OpticalSurface[i+1].curvature;
        OpticalSystem.OpticalSurface[i+1].curvature:=NewData[i+1];
      end;
    end else begin

      NewData[i+1]:=c[i]*DistanceIncr[i-OpticalSystem.TotalSurfaceNumber+1]+
         OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber+1].Distance;
      if NewData[i+1]<=0 then begin

      end else begin
        if Fixed[i-OpticalSystem.TotalSurfaceNumber+1+1]=True then begin
          OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber+1].Distance:=
            OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber+1].Distance+0;
        end else begin
          OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber+1].Distance:=NewData[i+1];
        end;
      end;

    end;
  end;


end;

procedure TSPCForm.qr_decomposition(Var a:TQRArray;Var n:integer;Var m:integer ;
                               Var q:TQRArray;Var r:TQRArray);

var i,j,k,l:integer;
    s,p:double;
begin

  gramm_schumidt(a,n,m,q);
  for k:=0 to m-1 do begin
    for j:=0 to k-1 do begin
      s:=0;
      for i:=0 to n-1 do begin
        s:=s+a[i,k]*q[i,j];
      end;
      r[j,k]:=s;
    end;
    s:=0;
    for i:=0 to n-1 do begin
      p:=a[i,k];
      for l:=0 to k-1 do begin
        p:=p-r[l,k]*q[i,l];
      end;
      s:=s+p*p;
    end;
      r[k,k]:=Sqrt(s);
    for j:=k+1 to m-1 do begin
      r[j,k]:=0
    end;
  end;
end;

procedure TSPCForm.gramm_schumidt(Var aTQRArray;Var n:integer; Var m:integer;Var q:TQRArray);
var i,j,k:integer;
    s:double;
begin

  for i:=0 to n-1 do begin
    for j:=0 to m-1 do begin
      q[i,j]:=a[i,j];
    end;
  end;
  for j:=0 to m-1 do begin
    s:=0;
    for i:=0 to n-1 do begin
      s:=s+q[i,j]*q[i,j];
    end;
    s:=1/ Sqrt(s);
    for i:=0 to n-1 do begin
      q[i,j]:=q[i,j]*s
    end;
    for k:=j+1 to m-1 do begin
      s:=0;
      for i:=0to n-1 do begin
        s:=s+q[i,k]*q[i,j];
      end;
      for i:=0 to n-1 do begin
        q[i,k]:=q[i,k]-s*q[i,j]
      end;
    end;
  end;

end;

procedure TSPCForm.SpinButton1DownClick(Sender: TObject);
begin
  if CurvetureRate>0.000001 then begin
    CurvetureRate:=CurvetureRate-0.000001;
    Edit1.Text:=FloatToStrF(CurvetureRate,ffGeneral,8,3);
  end else begin
    CurvetureRate:=0.000001;
    Edit1.Text:=FloatToStrF(CurvetureRate,ffGeneral,8,3);
  end;
end;

procedure TSPCForm.SpinButton1UpClick(Sender: TObject);
begin
  CurvetureRate:=CurvetureRate+0.000001;
  Edit1.Text:=FloatToStrF(CurvetureRate,ffGeneral,8,3);
end;

procedure TSPCForm.SpinButton2UpClick(Sender: TObject);
begin
  DistanceRate:=DistanceRate+0.005;
  Edit2.Text:=FloatToStr(DistanceRate);
end;

procedure TSPCForm.SpinButton2DownClick(Sender: TObject);
begin
  if DistanceRate>0.005 then begin
    DistanceRate:=DistanceRate-0.005;
    Edit2.Text:=FloatToStr(DistanceRate);
  end else begin
    DistanceRate:=0;
    Edit2.Text:=FloatToStr(DistanceRate);
  end;
end;

procedure TSPCForm.SpinButton3DownClick(Sender: TObject);
begin

  if InputAngleDecimal>=0.1 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     Edit3.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit3.Value+InputAngleDecimal;
  end else begin

  end;
  if InputAngleDecimal<0.1 then  begin
     InputAngleDecimal:=0;
     Edit3.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit3.Value+InputAngleDecimal;
  end;

  label20.Caption:=':'+FloatToStr(InputAngle);
  
end;

procedure TSPCForm.SpinButton3UpClick(Sender: TObject);
begin

  if InputAngleDecimal<0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal+0.1;
     Edit3.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit3.value+InputAngleDecimal;
  end else begin

  end;
   label20.Caption:=':'+FloatToStr(InputAngle);
end;

procedure TSPCForm.SpinEdit2Change(Sender: TObject);
begin
  PlusM:=Spinedit2.Value;
  Memo1.Clear;
  Memo1.Text:=TextList[PlusM];

  case PlusM of
    0:begin
      Label8.Visible:=False;Edit5.Visible:=False;SpinButton5.Visible:=False;
      Label9.Visible:=False;Edit6.Visible:=False;SpinButton6.Visible:=False;
      Label10.Visible:=False;Edit7.Visible:=False;SpinButton7.Visible:=False;
      Label11.Visible:=False;Edit8.Visible:=False;SpinButton8.Visible:=False;
      Label12.Visible:=False;Edit9.Visible:=False;SpinButton9.Visible:=False;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
      Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    1:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=False;Edit6.Visible:=False;SpinButton6.Visible:=False;
      Label10.Visible:=False;Edit7.Visible:=False;SpinButton7.Visible:=False;
      Label11.Visible:=False;Edit8.Visible:=False;SpinButton8.Visible:=False;
      Label12.Visible:=False;Edit9.Visible:=False;SpinButton9.Visible:=False;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    2:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=False;Edit7.Visible:=False;SpinButton7.Visible:=False;
      Label11.Visible:=False;Edit8.Visible:=False;SpinButton8.Visible:=False;
      Label12.Visible:=False;Edit9.Visible:=False;SpinButton9.Visible:=False;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;


    3:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=False;Edit8.Visible:=False;SpinButton8.Visible:=False;
      Label12.Visible:=False;Edit9.Visible:=False;SpinButton9.Visible:=False;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    4:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=False;Edit9.Visible:=False;SpinButton9.Visible:=False;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    5:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=True;Edit9.Visible:=True;SpinButton9.Visible:=True;
      Label13.Visible:=False;Edit10.Visible:=False;SpinButton10.Visible:=False;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    6:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=True;Edit9.Visible:=True;SpinButton9.Visible:=True;
      Label13.Visible:=True;Edit10.Visible:=True;SpinButton10.Visible:=TRue;
      Label14.Visible:=False;Edit11.Visible:=False;SpinButton11.Visible:=False;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    7:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=True;Edit9.Visible:=True;SpinButton9.Visible:=True;
      Label13.Visible:=True;Edit10.Visible:=True;SpinButton10.Visible:=TRue;
      Label14.Visible:=True;Edit11.Visible:=True;SpinButton11.Visible:=True;
      Label15.Visible:=False;Edit12.Visible:=False;SpinButton12.Visible:=False;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;
    end;

    8:begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=True;Edit9.Visible:=True;SpinButton9.Visible:=True;
      Label13.Visible:=True;Edit10.Visible:=True;SpinButton10.Visible:=TRue;
      Label14.Visible:=True;Edit11.Visible:=True;SpinButton11.Visible:=True;
      Label15.Visible:=True;Edit12.Visible:=True;SpinButton12.Visible:=True;
       Label16.Visible:=False;Edit13.Visible:=False;SpinButton13.Visible:=False;

    end else begin
      Label8.Visible:=True;Edit5.Visible:=True;SpinButton5.Visible:=True;
      Label9.Visible:=True;Edit6.Visible:=True;SpinButton6.Visible:=True;
      Label10.Visible:=True;Edit7.Visible:=True;SpinButton7.Visible:=True;
      Label11.Visible:=True;Edit8.Visible:=True;SpinButton8.Visible:=True;
      Label12.Visible:=True;Edit9.Visible:=True;SpinButton9.Visible:=True;
      Label13.Visible:=True;Edit10.Visible:=True;SpinButton10.Visible:=TRue;
      Label14.Visible:=True;Edit11.Visible:=True;SpinButton11.Visible:=True;
      Label15.Visible:=True;Edit12.Visible:=True;SpinButton12.Visible:=True;
      Label16.Visible:=TRue;Edit13.Visible:=True;SpinButton13.Visible:=True;
    end;

  end;


end;

procedure TSPCForm.SpinButton4DownClick(Sender: TObject);
begin
   if StrToFloat(Edit4.Text)<=1E+1 then begin
     Edit4.Text:='0';
     DumpingFactor:=StrToFloat(Edit4.Text);
   end else begin
     DumpingFactor:=DumpingFactor/10;
     Edit4.Text:=FloatToStrF(DumpingFactor,ffExponent,2,2);
   end;
end;

procedure TSPCForm.SpinButton4UpClick(Sender: TObject);
begin
  if StrToFloat(Edit4.Text)=0 then begin
     Edit4.Text:='1e+1';
     DumpingFactor:=StrToFloat(Edit4.Text);
   end else begin
     DumpingFactor:=DumpingFactor*10;
     Edit4.Text:=FloatToStrF(DumpingFactor,ffExponent,2,2);
   end;
end;

procedure TSPCForm.LSQ(Sender:TObject);
var k,j,i,n1,na1,na,kp:integer;
    temp,ss,tt,p:double;
begin
  for k:=1 to VarN do begin
    for j:=1 to VarN do begin
      ss:=0;
      for i:=1 to EquM do  begin
        ss:=ss+aLS[i,j]*aLS[i,k];
      end;
      SLS[j,k]:=ss;                //ɂ邩ɂ邩
    end;
  end;

  for j:=1 to VarN do begin
    tt:=0;
    for i:=1 to EquM do begin
      tt:=tt+aLS[i,j]*(YLS[i]+DeltaSum*DumpingFactor);//_sOt@N^[C
    end;
    TLS[j]:=tt;
  end;

  for j:=1 to VarN do begin
    for i:=1 to VarN do begin
      XLS[j,i]:=SLS[j,i];
    end;
  end;
  for i:=1 to VarN do begin
    XLS[i,VarN+1]:=TLS[i];
  end;

  n1:=VarN+1;
  for na:=1 to VarN do begin
    p:=0;
    na1:=na+1;
    for i:=na to VarN do begin
      if p>abs(XLS[i,na]) then begin

      end else begin
        p:=abs(XLS[i,na]);
        kp:=i;
      end;
    end;

    if p<1e-200 then begin
      ShowMessage('słB');
    end;

    for j:=na to n1 do begin
      temp:=XLS[na,j];
      XLS[na,j]:=XLS[kp,j];       //kp
      XLS[kp,j]:=temp;
    end;

    for j:=na1 to n1 do begin
      XLS[na,j]:=XLS[na,j]/XLS[na,na];
    end;

    for i:=1 to n1 do begin
      if i=na then begin

      end else begin
        for j:=na1 to n1 do begin
          XLS[i,j]:=XLS[i,j]-XLS[i,na]*XLS[na,j];
        end;
      end;
    end;

  end;
end;

procedure TSPCForm.NewDataSettingCurveture(Sender:TObject);
var i:integer;
 begin
  for i:=1 to OpticalSystem.TotalSurfaceNumber do begin

      if Fixed[i]=True then begin
        OpticalSystem.OpticalSurface[i].curvature:= OpticalSystem.OpticalSurface[i].curvature+0;
      end else begin
        OpticalSystem.OpticalSurface[i].curvature:=
          XLS[i,VarN+1]*CurvetureIncr[i]+OpticalSystem.OpticalSurface[i].curvature;
      end;


  end;


  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn3Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);

  BendingForm2.Button1.Click;

  CorrectedOptSys.CopyFrom(OpticalSystem);

  MaxSpotNumber:=15;
  SpotForm.SpotButton2.Click;
  UnitedDataForm.BitBtn1Click(Sender);
end;


procedure TSPCForm.Button3Click(Sender: TObject);
begin
  LSMForm.Button5.Click;
  self.Button1.Click;
end;

procedure TSPCForm.Button4Click(Sender: TObject);
var aTimes,i:integer;
begin
  aTimes:=SpinEdit1.Value;
  for i:=1 to aTimes do begin
    self.DeltaDistanceSetting;
    self.LSQ(Sender);
    self.NewDataSettingDistance(Sender);
  end;
end;

procedure TSPCForm.DeltaDistanceSetting;
var i,k,ii:integer;
    c:TSpectru;
    aZ,aY:Extended;
    aCounter,aC2,aC3:integer;
    s: Integer;
    j:integer;
    ss,tt,p:double;
    na1,na,kp,n1:integer;
    temp:double;

    aPrincipalRay:integer;
    aRC,aCC:integer;

begin

  MaxSpotNumber:=9;
  SpotForm.CulSpot;
  aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

  DeltaSum:=0;
  for j:=1 to   OpticalSystem.TotalSurfaceNumber-1 do begin
    if Fixed[j+OpticalSystem.TotalSurfaceNumber]=True then begin
      DistanceIncr[j]:=1e-10;                                   //0Zh~
      DeltaSum:=DeltaSum+DistanceIncr[j];
    end else begin
      DistanceIncr[j]:=OpticalSystem.OpticalMedium[j].Distance*DistanceRate;
      DeltaSum:=DeltaSum+DistanceIncr[j];
    end;
  end;

  aCounter:=0;
  aC2:=0;
  for i:=1 to 3 do  begin                                        //IWĩX|bgl 3
    for c:=nd to OpticalSystem.LastSpectru do begin
       for k:=1to MaxSpotNumber*MaxSpotNumber do begin

         if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
           aC2:=aC2+1;
          // OriginRayCheckJadg[aCounter]:=False;

         end else begin
           aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
           aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

           aCounter:=aCounter+1;
           OriginRayCheckJadg[aCounter]:=True;
           OriginSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
         end;

       end;
    end;
  end;



  DeltaFL[0]:=OpticalSystem.FocalLength[nd];
  DeltaBFL[0]:=OpticalSystem.BackFocus[nd];
  DeltaFLC[0]:=OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd];
  DeltaFLg[0]:=OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd];

  OpticalSystem.CalculateSphericalAberration(SA,OSC);
  opticalSystem.CalculateAS(MAS,SAS,InputAngle);
  OpticalSystem.CalculateDistortion(DIS,InputAngle);

  DeltaSA[0]:=SA[nd,trunc(MaxSANumber*0.9)];
  DeltaSC[0]:=OSC[trunc(MaxSANumber*0.9)];
  DeltaMAS[0]:=MAS[MaxAngleNumber];
  DeltaSAS[0]:=SAS[MaxAngleNumber];
  DeltaDS[0]:=DIS[MaxAngleNumber];

  for s:=1 to OpticalSystem.TotalSurfaceNumber-1do begin
                                //ʊԊuω
    OpticalSystem.OpticalMedium[s].Distance:=
        OpticalSystem.OpticalMedium[s].Distance+DistanceIncr[s];


      SpotForm.CulSpot;
      aCounter:=0;
      aC2:=0;
      for i:=1 to 3 do  begin
        for c:=nd to OpticalSystem.LastSpectru do begin
          for k:=1to MaxSpotNumber*MaxSpotNumber do begin
            
            if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
              aC2:=aC2+1;
             // RayCheckJadg[aCounter]:=False;

            end else begin
              aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
              aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

              aCounter:=aCounter+1;
              RayCheckJadg[aCounter]:=True;
              CorrectSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
              DeltaSPD[aCounter]:=CorrectSpotDiameter[aCounter]-OriginSpotDiameter[aCounter];
            end;

          end;
        end;
      //end;
    end;

    aC3:=0;
    for ii:=1 to aCounter do begin
      if RayCheckJadg[ii]=True then begin
         aC3:=aC3+1;
        aLS[aC3,s]:=DeltaSPD[ii]*Weight[0];
      end;
    end;

    OpticalSystem.ParAxialTrace(FinalOpt) ;
    DeltaFL[s]:=OpticalSystem.FocalLength[nd]-DeltaFL[0];
    DeltaBFL[s]:=OpticalSystem.BackFocus[nd]-DeltaBFL[0];
    DeltaFLC[s]:=(OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd])-DeltaFLC[0];
    DeltaFLg[s]:=(OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd])-DeltaFLg[0];

    OpticalSystem.CalculateSphericalAberration(SA,OSC);
    opticalSystem.CalculateAS(MAS,SAS,InputAngle);
    OpticalSystem.CalculateDistortion(DIS,InputAngle);

    DeltaSA[s]:=SA[nd,trunc(MaxSANumber*0.9)]-DeltaSA[0];
    DeltaSC[s]:=OSC[trunc(MaxSANumber*0.9)]-DeltaSC[0];
    DeltaMAS[s]:=MAS[MaxAngleNumber]-DeltaMAS[0];
    DeltaSAS[s]:=SAS[MaxAngleNumber]-DeltaSAS[0];
    DeltaDS[s]:=DIS[MaxAngleNumber]-DeltaDS[0];

    aLS[aC3+1,s]:=DeltaFL[s];
    aLS[aC3+2,s]:=DeltaBFL[s] ;
    aLS[aC3+3,s]:=DeltaFLC[s]*Weight[3];
    aLS[aC3+4,s]:=DeltaFLg[s]*Weight[4];
    aLS[aC3+5,s]:=DeltaSA[s]*Weight[5];
    aLS[aC3+6,s]:=DeltaSC[s]*Weight[6];
    aLS[aC3+7,s]:=DeltaMAS[s]*Weight[7];
    aLS[aC3+8,s]:=DeltaSAS[s]*Weight[8];
    aLS[aC3+9,s]:=DeltaDS[s]*Weight[9];

    OpticalSystem.CopyFrom(CorrectedOptSys);

  end;

 

  VarN:=OpticalSystem.TotalsurfaceNumber-1;
  EquM:=aC3+PlusM;

  for aRC := 0 to StringGrid1.RowCount - 1 do
    for aCC := 0 to StringGrid1.ColCount - 1 do
      StringGrid1.Cells[aCC,aRC] := '';

  for j := 1 to VarN do begin
    for i := 1 to EquM do begin
      StringGrid1.Cells[ 0,j]:=IntToStr(j);
      StringGrid1.Cells[ i,0]:=IntToStr(i);
    end;
  end;

  for j := 1 to VarN do begin
    for i := 1 to EquM do begin
      StringGrid1.Cells[ i,j]:=FloatToStrF(aLS[i,j],ffgeneral,5,3);
    end;
  end;

//////////////////////////////////////////////////////////////////////////////////

  for j:=1 to aC3 do begin
    YLS[j]:=-1 * (OriginSpotDiameter[j])*Weight[0];  //ڕWl
  end;
  YLS[aC3+1]:=0;
  YLS[aC3+2]:=0;
  YLS[aC3+3]:=-1*DeltaFLC[0]*Weight[3];
  YLS[aC3+4]:=-1*DeltaFLg[0]*Weight[4];
  YLS[aC3+5]:=-1*DeltaSA[0]*Weight[5];
  YLS[aC3+6]:=-1*DeltaSC[0]*Weight[6];
  YLS[aC3+7]:=-1*DeltaMAS[0]*Weight[7];
  YLS[aC3+8]:=-1*DeltaSAS[0]*Weight[8];
   YLS[aC3+9]:=-1*DeltaDS[0]*Weight[9];
   
  for i := 1 to EquM do begin
    StringGrid1.Cells[i,VarN+2]:=FloatToStrF(YLS[i],ffgeneral,5,3);
  end;


end;

procedure TSPCForm.NewDataSettingDistance(Sender:TObject);
var i:integer;
    aNewData:double;
 begin
  for i:=1 to OpticalSystem.TotalSurfaceNumber-1 do begin

      if Fixed[i+OpticalSystem.TotalSurfaceNumber]=True then begin


      end else begin
        aNewData:=XLS[i,VarN+1]*DistanceIncr[i]+OpticalSystem.OpticalMedium[i].Distance;
        if aNewData<=0 then begin

        end else begin

        OpticalSystem.OpticalMedium[i].Distance:=
          XLS[i,VarN+1]
            *DistanceIncr[i]+OpticalSystem.OpticalMedium[i].Distance;
        end;
      end;


  end;


  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn3Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);

  BendingForm2.Button1.Click;

  CorrectedOptSys.CopyFrom(OpticalSystem);

  MaxSpotNumber:=15;
  SpotForm.SpotButton2.Click;

end;

procedure TSPCForm.Button5Click(Sender: TObject);
var aTimes,i:integer;
begin
  aTimes:=SpinEdit1.Value;

  if RadioButton1.Checked=True then begin
    for i:=1 to aTimes do begin
      self.DeltaSetting;
      self.LSQ(Sender);
      self.NewDataSetting(Sender);
    end;
  end;

  if RadioButton2.Checked=True then begin
    for i:=1 to aTimes do begin
      self.DeltaSetting;
      self.QR;

    UnitedDataForm.BitBtn2Click(Sender);
    UnitedDataForm.BitBtn3Click(Sender);
    UnitedDataForm.BitBtn18Click(Sender);
    BendingForm2.Button1.Click;

    CorrectedOptSys.CopyFrom(OpticalSystem);

    MaxSpotNumber:=15;
    SpotForm.SpotButton2.Click;
    end;
  end;

end;

procedure TSPCForm.DeltaSetting;
var i,k,ii:integer;
    c:TSpectru;
    aZ,aY:Extended;
    aCounter,aC2,aC3:integer;
    s: Integer;
    j:integer;
    ss,tt,p:double;
    na1,na,kp,n1:integer;
    temp:double;

    aPrincipalRay:integer;
    aRC,aCC:integer;
    aNewData:double;
begin

  MaxSpotNumber:=9;
  SpotForm.CulSpot;
  aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

  DeltaSum:=0;
  for j:=1 to   OpticalSystem.TotalSurfaceNumber do begin
    if OpticalSystem.OpticalSurface[j].Curvature=0 then  begin
      CurvetureIncr[j]:=0;
      DeltaSum:=DeltaSum+CurvetureIncr[j];
    end else begin
      if Fixed[j]=true then begin
        CurvetureIncr[j]:=1e-20;                                //0Z
        DeltaSum:=DeltaSum+CurvetureIncr[j];
      end else begin
        CurvetureIncr[j]:=CurvetureRate;
        DeltaSum:=DeltaSum+CurvetureIncr[j];
      end;
    end;
  end;
  for j:=1 to   OpticalSystem.TotalSurfaceNumber-1 do begin
    if Fixed[j+OpticalSystem.TotalSurfaceNumber]=True then begin
      DistanceIncr[j]:=1e-10;
      DeltaSum:=DeltaSum+DistanceIncr[j];
    end else begin
      DistanceIncr[j]:=DistanceRate;
      DeltaSum:=DeltaSum+DistanceIncr[j];
    end;
  end;


  aCounter:=0;
  aC2:=0;
  for i:=1 to 3 do  begin                                        //IWĩX|bgl 3
    for c:=nd to OpticalSystem.LastSpectru do begin
       for k:=1to MaxSpotNumber*MaxSpotNumber do begin

         if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
           aC2:=aC2+1;
          // OriginRayCheckJadg[aCounter]:=False;

         end else begin
           aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
           aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

           aCounter:=aCounter+1;
           OriginRayCheckJadg[aCounter]:=True;
           OriginSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
         end;

       end;
    end;
  end;



  DeltaFL[0]:=OpticalSystem.FocalLength[nd];
  DeltaBFL[0]:=OpticalSystem.BackFocus[nd];
  DeltaFLC[0]:=OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd];
  DeltaFLg[0]:=OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd];

  OpticalSystem.CalculateSphericalAberration(SA,OSC);
  opticalSystem.CalculateAS(MAS,SAS,InputAngle);
  OpticalSystem.CalculateDistortion( DIS, InputAngle);
   
  DeltaSA[0]:=SA[nd,trunc(MaxSANumber*0.9)];
  DeltaSC[0]:=OSC[trunc(MaxSANumber*0.9)];
  DeltaMAS[0]:=MAS[MaxAngleNumber];
  DeltaSAS[0]:=SAS[MaxAngleNumber];
  DEltaDS[0]:=DIS[MaxAngleNumber];

  for s:=1 to OpticalSystem.TotalSurfaceNumber*2-1do begin
    if s<=OpticalSystem.TotalSurfaceNumber then begin
      if Fixed[s]=True then begin
        OpticalSystem.OpticalSurface[s].Curvature:=OpticalSystem.OpticalSurface[s].Curvature+CurvetureIncr[s];
      end else begin                                                                                       //ȗω
        OpticalSystem.OpticalSurface[s].Curvature:=OpticalSystem.OpticalSurface[s].Curvature+CurvetureIncr[s];
      end;

      SpotForm.CulSpot;
      aCounter:=0;
      aC2:=0;
      for i:=1 to 3 do  begin
        for c:=nd to OpticalSystem.LastSpectru do begin
          for k:=1to MaxSpotNumber*MaxSpotNumber do begin

            if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
              aC2:=aC2+1;
             // RayCheckJadg[aCounter]:=False;

            end else begin
              aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
              aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

              aCounter:=aCounter+1;
              RayCheckJadg[aCounter]:=True;
              CorrectSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
              DeltaSPD[aCounter]:=CorrectSpotDiameter[aCounter]-OriginSpotDiameter[aCounter];
            end;

          end;
        end;
      end;

    end else begin
      if Fixed[s]=True then begin
         OpticalSystem.OpticalMedium[s-OpticalSystem.TotalSurfaceNumber].Distance:=
         OpticalSystem.OpticalMedium[s-OpticalSystem.TotalSurfaceNumber].Distance+
          DistanceIncr[s-OpticalSystem.TotalSurfaceNumber];
      end else begin                                                               //ʊԊuω
         OpticalSystem.OpticalMedium[s-OpticalSystem.TotalSurfaceNumber].Distance:=
         OpticalSystem.OpticalMedium[s-OpticalSystem.TotalSurfaceNumber].Distance+
          DistanceIncr[s-OpticalSystem.TotalSurfaceNumber];
      end;

      SpotForm.CulSpot;
      aCounter:=0;
      aC2:=0;
      for i:=1 to 3 do  begin
        for c:=nd to OpticalSystem.LastSpectru do begin
          for k:=1to MaxSpotNumber*MaxSpotNumber do begin

            if SpotForm.GetSpotPointY(i,c,k)=NULL then begin
              aC2:=aC2+1;
             // RayCheckJadg[aCounter]:=False;

            end else begin
              aZ:=SpotForm.GetSpotPointZ(i,nd,aPrincipalRay)-SpotForm.GetSpotPointZ(i,c,k);
              aY:=SpotForm.GetSpotPointY(i,nd,aPrincipalRay)-SpotForm.GetSpotPointY(i,c,k);

              aCounter:=aCounter+1;
              RayCheckJadg[aCounter]:=True;
              CorrectSpotDiameter[aCounter]:=Sqrt((aZ*aZ)+(aY*aY));
              DeltaSPD[aCounter]:=CorrectSpotDiameter[aCounter]-OriginSpotDiameter[aCounter];
            end;

          end;
        end;
      end;
    end;

    aC3:=0;
    for ii:=1 to aCounter do begin
      if RayCheckJadg[ii]=True then begin
         aC3:=aC3+1;
        aLS[aC3,s]:=DeltaSPD[ii];
      end;
    end;

    OpticalSystem.ParAxialTrace(FinalOpt) ;
    DeltaFL[s]:=OpticalSystem.FocalLength[nd]-DeltaFL[0];
    DeltaBFL[s]:=OpticalSystem.BackFocus[nd]-DeltaBFL[0];
    DeltaFLC[s]:=(OpticalSystem.FocalLength[nC]-OpticalSystem.FocalLength[nd])-DeltaFLC[0];
    DeltaFLg[s]:=(OpticalSystem.FocalLength[ng]-OpticalSystem.FocalLength[nd])-DeltaFLg[0];

    OpticalSystem.CalculateSphericalAberration(SA,OSC);
    opticalSystem.CalculateAS(MAS,SAS,InputAngle);
    OpticalSystem.CalculateDistortion( DIS, InputAngle);

    DeltaSA[s]:=SA[nd,trunc(MaxSANumber*0.9)]-DeltaSA[0];
    DeltaSC[s]:=OSC[trunc(MaxSANumber*0.9)]-DeltaSC[0];
    DeltaMAS[s]:=MAS[MaxAngleNumber]-DeltaMAS[0];
    DeltaSAS[s]:=SAS[MaxAngleNumber]-DeltaSAS[0];
    DeltaDS[s]:=DIS[MaxAngleNumber]-DeltaDS[0];

    aLS[aC3+1,s]:=DeltaFL[s];
    aLS[aC3+2,s]:=DeltaBFL[s] ;
    aLS[aC3+3,s]:=DeltaFLC[s]*Weight[3];
    aLS[aC3+4,s]:=DeltaFLg[s]*Weight[4];
    aLS[aC3+5,s]:=DeltaSA[s]*Weight[5];
    aLS[aC3+6,s]:=DeltaSC[s]*Weight[6];
    aLS[aC3+7,s]:=DeltaMAS[s]*Weight[7];
    aLS[aC3+8,s]:=DeltaSAS[s]*Weight[8];
    aLS[aC3+9,s]:=DeltaDS[s]*Weight[9];

    OpticalSystem.CopyFrom(CorrectedOptSys);

  end;


  VarN:=OpticalSystem.TotalSurfaceNumber*2-1;
  EquM:=aC3+PlusM;

  for j:=1 to aC3 do begin
    YLS[j]:=-1 * (OriginSpotDiameter[j])*Weight[0];  //ڕWl
  end;
  YLS[aC3+1]:=0;
  YLS[aC3+2]:=0;
  YLS[aC3+3]:=-1*DeltaFLC[0]*Weight[3];
  YLS[aC3+4]:=-1*DeltaFLg[0]*Weight[4];
  YLS[aC3+5]:=-1*DeltaSA[0]*Weight[5];
  YLS[aC3+6]:=-1*DeltaSC[0]*Weight[6];
  YLS[aC3+7]:=-1*DeltaMAS[0]*Weight[7];
  YLS[aC3+8]:=-1*DeltaSAS[0]*Weight[8];
   YLS[aC3+9]:=-1*DeltaDS[0]*Weight[9];
   

//////////////////////////////////////////////////////////////////////////////////
  if CheckBox1.Checked=True then begin

    for aRC := 0 to StringGrid1.RowCount - 1 do
      for aCC := 0 to StringGrid1.ColCount - 1 do
        StringGrid1.Cells[aCC,aRC] := '';

    for j := 1 to VarN do begin
      for i := 1 to EquM do begin
        StringGrid1.Cells[ 0,j]:=IntToStr(j);
        StringGrid1.Cells[ i,0]:=IntToStr(i);
      end;
    end;

    for j := 1 to VarN do begin
      for i := 1 to EquM do begin
        StringGrid1.Cells[ i,j]:=FloatToStrF(aLS[i,j],ffgeneral,5,3);
      end;
    end;


    for i := 1 to EquM do begin
      StringGrid1.Cells[i,VarN+2]:=FloatToStrF(YLS[i],ffgeneral,5,3);
    end;



  end;
///////////////////////////////////////////////////////////////////////////////////////////


end;

procedure TSPCForm.NewDataSetting(Sender:TObject);
var i:integer;
    aNewData:double;
 begin
  for i:=1 to OpticalSystem.TotalSurfaceNumber*2-1 do begin
    if i<=OpticalSystem.TotalsurfaceNumber then begin
      if Fixed[i]=True then begin

      end else begin
        OpticalSystem.OpticalSurface[i].curvature:=
          XLS[i,VarN+1]*CurvetureIncr[i]+OpticalSystem.OpticalSurface[i].curvature;
      end;
    end else begin
      aNewData:=XLS[i-OpticalSystem.TotalSurfaceNumber,VarN+1]*DistanceIncr[i-OpticalSystem.TotalSurfaceNumber]
                +OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber].Distance;

      if Fixed[i]=True then begin
        if aNewData<=0 then begin

        end else begin

        end;
      end else begin
        if aNewData<=0 then begin

        end else begin
        OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber].Distance:=
          XLS[i-OpticalSystem.TotalSurfaceNumber,VarN+1]
            *DistanceIncr[i-OpticalSystem.TotalSurfaceNumber]+
             OpticalSystem.OpticalMedium[i-OpticalSystem.TotalSurfaceNumber].Distance;
        end;
      end;
    end;

  end;


  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn3Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);

  BendingForm2.Button1.Click;

  CorrectedOptSys.CopyFrom(OpticalSystem);

  MaxSpotNumber:=15;
  SpotForm.SpotButton2.Click;

end;


procedure TSPCForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
self.Visible:=False;
end;

procedure TSPCForm.SpinButton5DownClick(Sender: TObject);
begin

  FLIncr:=FLIncr-1;
  Edit5.Text:=FloatToStr(FLIncr);

end;

procedure TSPCForm.SpinButton5UpClick(Sender: TObject);
begin
  FLIncr:=FlIncr+1;
  Edit5.Text:=FloatToStr(FLIncr);
end;

procedure TSPCForm.SpinButton6DownClick(Sender: TObject);
begin
  BFLIncr:=BFLIncr-1;
  Edit6.Text:=FloatToStr(BFLIncr);
end;

procedure TSPCForm.SpinButton6UpClick(Sender: TObject);
begin
  BFLIncr:=BFLIncr+1;
  Edit6.Text:=FloatToStr(BFLIncr);
end;

procedure TSPCForm.SpinButton7DownClick(Sender: TObject);
begin

  if Weight[3]>=0.1 then begin
    Weight[3]:=Weight[3]-0.1;
    Edit7.Text:=FloatToStr(Weight[3]);
  end else begin

  end;

  if Weight[3]<0.1 then begin
    Weight[3]:=0;
     Edit7.Text:=FloatToStr(Weight[3]);
  end;

end;

procedure TSPCForm.SpinButton7UpClick(Sender: TObject);
begin
  Weight[3]:=Weight[3]+0.1;
  Edit7.Text:=FloatToStr(Weight[3]);
end;

procedure TSPCForm.SpinButton8DownClick(Sender: TObject);
begin

  if Weight[4]>=0.1 then begin
    Weight[4]:=Weight[4]-0.1;
    Edit8.Text:=FloatToStr(Weight[4]);
  end else begin

  end;

  if Weight[4]<0.1 then begin
    Weight[4]:=0;
     Edit8.Text:=FloatToStr(Weight[4]);
  end;

end;

procedure TSPCForm.SpinButton8UpClick(Sender: TObject);
begin
  Weight[4]:=Weight[4]+0.1;
  Edit8.Text:=FloatToStr(Weight[4]);
end;

procedure TSPCForm.SpinButton9DownClick(Sender: TObject);
begin

  if Weight[5]>=0.1 then begin
    Weight[5]:=Weight[5]-0.1;
    Edit9.Text:=FloatToStr(Weight[5]);
  end else begin

  end;

  if Weight[5]<0.1 then begin
    Weight[5]:=0;
     Edit9.Text:=FloatToStr(Weight[5]);
  end;

end;

procedure TSPCForm.SpinButton9UpClick(Sender: TObject);
begin
  Weight[5]:=Weight[5]+0.1;
  Edit9.Text:=FloatToStr(Weight[5]);
end;

procedure TSPCForm.SpinButton10DownClick(Sender: TObject);
begin

  if Weight[6]>=0.1 then begin
    Weight[6]:=Weight[6]-0.1;
    Edit10.Text:=FloatToStr(Weight[6]);
  end else begin

  end;

  if Weight[6]<0.1 then begin
    Weight[6]:=0;
     Edit10.Text:=FloatToStr(Weight[6]);
  end;

end;

procedure TSPCForm.SpinButton10UpClick(Sender: TObject);
begin
  Weight[6]:=Weight[6]+0.1;
  Edit10.Text:=FloatToStr(Weight[6]);
end;

procedure TSPCForm.SpinButton11DownClick(Sender: TObject);
begin

  if Weight[7]>=0.1 then begin
    Weight[7]:=Weight[7]-0.1;
    Edit11.Text:=FloatToStr(Weight[7]);
  end else begin

  end;

  if Weight[7]<0.1 then begin
    Weight[7]:=0;
     Edit11.Text:=FloatToStr(Weight[7]);
  end;

end;

procedure TSPCForm.SpinButton11UpClick(Sender: TObject);
begin
  Weight[7]:=Weight[7]+0.1;
  Edit11.Text:=FloatToStr(Weight[7]);
end;

procedure TSPCForm.SpinButton12DownClick(Sender: TObject);
begin

  if Weight[8]>=0.1 then begin
    Weight[8]:=Weight[8]-0.1;
    Edit12.Text:=FloatToStr(Weight[8]);
  end else begin

  end;

  if Weight[8]<0.1 then begin
    Weight[8]:=0;
     Edit12.Text:=FloatToStr(Weight[8]);
  end;

end;

procedure TSPCForm.SpinButton12UpClick(Sender: TObject);
begin
  Weight[8]:=Weight[8]+0.1;
  Edit12.Text:=FloatToStr(Weight[8]);
end;

procedure TSPCForm.SpinButton13DownClick(Sender: TObject);
begin

  if Weight[9]>=0.1 then begin
    Weight[9]:=Weight[9]-0.1;
    Edit13.Text:=FloatToStr(Weight[9]);
  end else begin

  end;

  if Weight[9]<0.1 then begin
    Weight[9]:=0;
     Edit13.Text:=FloatToStr(Weight[9]);
  end;

end;

procedure TSPCForm.SpinButton13UpClick(Sender: TObject);
begin
  Weight[9]:=Weight[9]+0.1;
  Edit13.Text:=FloatToStr(Weight[9]);
end;

procedure TSPCForm.SpinButton14UpClick(Sender: TObject);
begin
  Weight[0]:=Weight[0]+0.1;
  Edit14.Text:=FloatToStr(Weight[0]);
end;

procedure TSPCForm.SpinButton14DownClick(Sender: TObject);
begin
  if Weight[0]>=0.1 then begin
    Weight[0]:=Weight[0]-0.1;
    Edit14.Text:=FloatToStr(Weight[0]);
  end else begin

  end;

  if Weight[0]<0.1 then begin
    Weight[0]:=0;
     Edit14.Text:=FloatToStr(Weight[0]);
  end;

end;

procedure TSPCForm.SpinEdit3Change(Sender: TObject);
begin
  InputAngle:=SpinEdit3.Value+InputAngleDecimal;
  label20.Caption:=':'+FloatToStr(InputAngle);
end;

procedure TSPCForm.Button6Click(Sender: TObject);
begin
  LSMForm.Button3.Click;
  self.Button1.Click;
end;

end.


