unit GlassData;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, StrGrdIO, Grids, Math ,

  MainForm, OptSurface,OptMedium;

type
  TGlassDataForm = class(TForm)
    IndexGrid: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button9: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure IndexGridClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    
    procedure IndexGridDblClick(Sender: TObject);
    procedure Button9Click(Sender: TObject);
      procedure FormCreate(Sender:TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private 錾 }
    SelectedRow: integer;
    FilePath: String;
    StringGridIONC:TStringGridIO;

  public
    { Public 錾 }
    SelectedDataIndex: integer;


  end;

var
  GlassDataForm: TGlassDataForm;

implementation

uses DataGrid, MediumDataGrid, UnitedData;

{$R *.dfm}

procedure TGlassDataForm. FormCreate(Sender:TObject);
begin
  Caption:='GlassData';
  StringGridIONC:=TStringGridIO.Create(Owner);
  StringGridIONC.TargetGrid:=IndexGrid;
end;

procedure TGlassDataForm.Button1Click(Sender: TObject);

begin

   StringGridIONC.Clear;

{
  if OpenDialog1.Execute then begin
      StringGridIO1.LoadFromFile(OpenDialog1.FileName,#9,False);
  end;

  Edit1.Text:=ChangeFileExt(ExtractFileName(OpenDialog1.FileName),'');
 }


   StringGridIONC.LoadFromFile(FilePath + '\HOYA.txt',#9,False);
   Edit1.Text:=ChangeFileExt('HOYA.txt','');
   IndexGrid.FixedRows:=1;
   SelectedRow:=IndexGrid.Row;

end;


procedure TGlassDataForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  self.visible:=False;
end;

procedure TGlassDataForm.Button2Click(Sender: TObject);
var
    Medium: TOpticalMedium;
    A0,A1,A2,A3,A4,A5,
    W2,Wm2,Wm4,Wm6,Wm8, aNs: double;

begin

  Medium:=OpticalSystem.OpticalMedium[SelectedDataIndex];

  if Edit1.Text='HOYA' then begin
    Medium.GlassName:=IndexGrid.Cells[1,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[4,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[9,SelectedRow]) );

    Medium.RefractiveIndex[ns]:=StrToFloat( TrimRight(IndexGrid.Cells[10,SelectedRow]) );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[12,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[13,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[3,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[6,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[19,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[21,SelectedRow]) );

    Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[22,SelectedRow]) );

    if IndexGrid.Cells[23,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[22,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[23,SelectedRow]) );
    end;

  end;



  if Edit1.Text='Ohara' then begin
    Medium.GlassName:=IndexGrid.Cells[1,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[24,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[8,SelectedRow]) );

    Medium.RefractiveIndex[ns]:=StrToFloat( TrimRight(IndexGrid.Cells[9,SelectedRow]) );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[11,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[12,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[16,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[17,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[18,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[21,SelectedRow]) );

    Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[22,SelectedRow]) );

    if IndexGrid.Cells[23,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[22,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[23,SelectedRow]) );
    end;

  end;


  if Edit1.Text='schott' then begin
    Medium.GlassName:=IndexGrid.Cells[0,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[3,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[120,SelectedRow]) );

    Medium.RefractiveIndex[ns]:=StrToFloat( TrimRight(IndexGrid.Cells[121,SelectedRow]) );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[122,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[123,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[1,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[2,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[129,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[131,SelectedRow]) );


    if IndexGrid.Cells[132,SelectedRow]='' then begin
      Medium.RefractiveIndex[nh]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[131,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[132,SelectedRow]) );
    end;


    if IndexGrid.Cells[133,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//Medium.RefractiveIndex[nh];
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[133,SelectedRow]) );
    end;

  end;


  if Edit1.Text='sumita' then begin
    Medium.GlassName:=IndexGrid.Cells[1,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[2,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[6,SelectedRow]) );

    //SvZ
    A0:=StrToFloat( TrimRight(IndexGrid.Cells[44,SelectedRow]) );
    A1:=StrToFloat( TrimRight(IndexGrid.Cells[45,SelectedRow]) );
    A2:=StrToFloat( TrimRight(IndexGrid.Cells[46,SelectedRow]) );
    A3:=StrToFloat( TrimRight(IndexGrid.Cells[47,SelectedRow]) );
    A4:=StrToFloat( TrimRight(IndexGrid.Cells[48,SelectedRow]) );
    A5:=StrToFloat( TrimRight(IndexGrid.Cells[49,SelectedRow]) );
    
    W2:=power(0.85211,2);
    Wm2:=power(0.85211,-2);
    Wm4:=Power(0.85211,-4);
    Wm6:=power(0.85211,-6);
    Wm8:=power(0.85211,-8);


    aNs:=sqrt(A0+A1*W2+A2*Wm2+A3*Wm4+A4*Wm6+A5*Wm8);


    Medium.RefractiveIndex[ns]:=StrToFloat(
                                FormatFloat('0.00000',aNs)
                                );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[8,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[9,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[12,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[13,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[14,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[16,SelectedRow]) );

    Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[18,SelectedRow]) );

    if IndexGrid.Cells[19,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[18,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[19,SelectedRow]) );
    end;
    
    if IndexGrid.Cells[19,SelectedRow]='0' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[18,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[19,SelectedRow]) );
    end;



  end;


  if Edit1.Text='OldSchott' then begin
    Medium.GlassName:=IndexGrid.Cells[1,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[2,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[3,SelectedRow]) );

    Medium.RefractiveIndex[ns]:=StrToFloat( TrimRight(IndexGrid.Cells[4,SelectedRow]) );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[5,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[6,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[7,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[8,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[9,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[10,SelectedRow]) );

    Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[11,SelectedRow]) );

    if IndexGrid.Cells[12,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[11,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[12,SelectedRow]) );
    end;

   end;

  if Edit1.Text='HIKARI' then begin
    Medium.GlassName:=IndexGrid.Cells[0,SelectedRow];

    Medium.AbbeNumber:=StrToFloat( TrimRight(IndexGrid.Cells[12,SelectedRow]) );

    Medium.RefractiveIndex[nt]:=StrToFloat( TrimRight(IndexGrid.Cells[2,SelectedRow]) );

    Medium.RefractiveIndex[ns]:=StrToFloat( TrimRight(IndexGrid.Cells[3,SelectedRow]) );

    Medium.RefractiveIndex[nr]:=StrToFloat( TrimRight(IndexGrid.Cells[4,SelectedRow]) );

    Medium.RefractiveIndex[nC]:=StrToFloat( TrimRight(IndexGrid.Cells[5,SelectedRow]) );

    Medium.RefractiveIndex[nd]:=StrToFloat( TrimRight(IndexGrid.Cells[6,SelectedRow]) );

    Medium.RefractiveIndex[ne]:=StrToFloat( TrimRight(IndexGrid.Cells[7,SelectedRow]) );

    Medium.RefractiveIndex[nF]:=StrToFloat( TrimRight(IndexGrid.Cells[8,SelectedRow]) );

    Medium.RefractiveIndex[ng]:=StrToFloat( TrimRight(IndexGrid.Cells[9,SelectedRow]) );

    Medium.RefractiveIndex[nh]:=StrToFloat( TrimRight(IndexGrid.Cells[10,SelectedRow]) );

    if IndexGrid.Cells[11,SelectedRow]='' then begin
      Medium.RefractiveIndex[ni]:=1.0;//StrToFloat( TrimRight(IndexGrid.Cells[11,SelectedRow]) );
    end else begin
      Medium.RefractiveIndex[ni]:=StrToFloat( TrimRight(IndexGrid.Cells[11,SelectedRow]) );
    end;

  end;



  FormPOPS.DataIsChanged;
  GlassDataForm.Visible:=False;


end;

procedure TGlassDataForm.IndexGridClick(Sender: TObject);
begin

    SelectedRow:=IndexGrid.Row;

end;

procedure TGlassDataForm.FormShow(Sender: TObject);
begin
    if SelectedRow=0 then begin
      SelectedRow:=1;
    end;

     FilePath:=ExtractFilePath(Application.ExeName);

     
end;



procedure TGlassDataForm.Button3Click(Sender: TObject);
begin
  StringGridIONC.Clear;
  StringGridIONC.LoadFromFile(FilePath +'\Ohara.txt',#9,False);
  Edit1.Text:='Ohara';

  IndexGrid.FixedRows:=2;
  IndexGrid.Row:=2;
  SelectedRow:=IndexGrid.Row;
end;

procedure TGlassDataForm.Button4Click(Sender: TObject);
begin
  StringGridIONC.Clear;
  StringGridIONC.LoadFromFile(FilePath +'\schott.txt',#9,False);
  Edit1.Text:='schott';

  IndexGrid.FixedRows:=7;
  IndexGrid.FixedCols:=0;
  IndexGrid.Row:=7;
  SelectedRow:=IndexGrid.Row;
end;

procedure TGlassDataForm.Button5Click(Sender: TObject);
begin
  StringGridIONC.Clear;
  StringGridIONC.LoadFromFile(FilePath +'\sumita.txt',#9,False);
  Edit1.Text:='sumita';

  IndexGrid.FixedRows:=3;
  IndexGrid.FixedCols:=1;
  IndexGrid.Row:=3;
  SelectedRow:=IndexGrid.Row;
end;

procedure TGlassDataForm.Button6Click(Sender: TObject);
begin
  StringGridIONC.Clear;
  StringGridIONC.LoadFromFile(FilePath +'\OldSchott.txt',#9,False);
  Edit1.Text:='OldSchott';

  IndexGrid.FixedRows:=1;
  IndexGrid.FixedCols:=1;
  IndexGrid.Row:=1;
  SelectedRow:=IndexGrid.Row;
end;

procedure TGlassDataForm.Button8Click(Sender: TObject);
begin
  StringGridIONC.Clear;
  StringGridIONC.LoadFromFile(FilePath +'\HIKARI.txt',#9,False);
  Edit1.Text:='HIKARI';

  IndexGrid.FixedRows:=1;
  IndexGrid.FixedCols:=1;
  IndexGrid.Row:=1;
  SelectedRow:=IndexGrid.Row;
end;

procedure TGlassDataForm.Button7Click(Sender: TObject);
var Medium: TOpticalMedium;
begin
  StringGridIONC.Clear;

  Edit1.Text:='air';

  IndexGrid.FixedRows:=1;
  IndexGrid.FixedCols:=1;
  IndexGrid.Row:=1;
  SelectedRow:=IndexGrid.Row;

  Medium:=OpticalSystem.OpticalMedium[SelectedDataIndex];


  Medium.GlassName:='air';

  Medium.AbbeNumber:=1;

  Medium.RefractiveIndex[nt]:=1;

  Medium.RefractiveIndex[ns]:=1;

  Medium.RefractiveIndex[nr]:=1;

  Medium.RefractiveIndex[nC]:=1;

  Medium.RefractiveIndex[nd]:=1;

  Medium.RefractiveIndex[ne]:=1;

  Medium.RefractiveIndex[nF]:=1;

  Medium.RefractiveIndex[ng]:=1;

  Medium.RefractiveIndex[nh]:=1;

  Medium.RefractiveIndex[ni]:=1;

  IndexGrid.Cells[0,1]:='Air';
  IndexGrid.Cells[1,0]:='nt';
  IndexGrid.Cells[2,0]:='ns';
  IndexGrid.Cells[3,0]:='nr';
  IndexGrid.Cells[4,0]:='nC';
  IndexGrid.Cells[5,0]:='nd';
  IndexGrid.Cells[6,0]:='ne';
  IndexGrid.Cells[7,0]:='nF';
  IndexGrid.Cells[8,0]:='ng';
  IndexGrid.Cells[9,0]:='nh';
  IndexGrid.Cells[10,0]:='ni';

  IndexGrid.Cells[1,1]:=floatToStr(Medium.RefractiveIndex[nt]);
  IndexGrid.Cells[2,1]:=floatToStr(Medium.RefractiveIndex[ns]);
  IndexGrid.Cells[3,1]:=floatToStr(Medium.RefractiveIndex[nr]);
  IndexGrid.Cells[4,1]:=floatToStr(Medium.RefractiveIndex[nC]);
  IndexGrid.Cells[5,1]:=floatToStr(Medium.RefractiveIndex[nd]);
  IndexGrid.Cells[6,1]:=floatToStr(Medium.RefractiveIndex[ne]);
  IndexGrid.Cells[7,1]:=floatToStr(Medium.RefractiveIndex[nF]);
  IndexGrid.Cells[8,1]:=floatToStr(Medium.RefractiveIndex[ng]);
  IndexGrid.Cells[9,1]:=floatToStr(Medium.RefractiveIndex[nh]);
  IndexGrid.Cells[10,1]:=floatToStr(Medium.RefractiveIndex[ni]);


  if ( DataGridForm.FlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
  end;


  FormPOPS.DataIsChanged;
  GlassDataForm.Visible:=False;
end;




procedure TGlassDataForm.IndexGridDblClick(Sender: TObject);
begin
    Button2Click(sender);
end;

procedure TGlassDataForm.Button9Click(Sender: TObject);
var Medium: TOpticalMedium;
begin

    
    Medium:=OpticalSystem.OpticalMedium[SelectedDataIndex];

    Medium.RefractiveIndex[nt]:= Medium.RefractiveIndex[nt]*-1;

    Medium.RefractiveIndex[ns]:= Medium.RefractiveIndex[ns]*-1;

    Medium.RefractiveIndex[nr]:= Medium.RefractiveIndex[nr]*-1;

    Medium.RefractiveIndex[nC]:= Medium.RefractiveIndex[nC]*-1;

    Medium.RefractiveIndex[nd]:= Medium.RefractiveIndex[nd]*-1;

    Medium.RefractiveIndex[ne]:= Medium.RefractiveIndex[ne]*-1;

    Medium.RefractiveIndex[nF]:= Medium.RefractiveIndex[nF]*-1;

    Medium.RefractiveIndex[ng]:= Medium.RefractiveIndex[ng]*-1;

    Medium.RefractiveIndex[nh]:= Medium.RefractiveIndex[nh]*-1;

    Medium.RefractiveIndex[ni]:= Medium.RefractiveIndex[ni]*-1;

  if (Medium.GlassName='air')or (Medium.GlassName='Air') then begin
    StringGridIONC.Clear;
    IndexGrid.Cells[0,1]:='air';
    IndexGrid.Cells[1,0]:='nt';
    IndexGrid.Cells[2,0]:='ns';
    IndexGrid.Cells[3,0]:='nr';
    IndexGrid.Cells[4,0]:='nC';
    IndexGrid.Cells[5,0]:='nd';
    IndexGrid.Cells[6,0]:='ne';
    IndexGrid.Cells[7,0]:='nF';
    IndexGrid.Cells[8,0]:='ng';
    IndexGrid.Cells[9,0]:='nh';
    IndexGrid.Cells[10,0]:='ni';

    IndexGrid.Cells[1,1]:=floatToStr(Medium.RefractiveIndex[nt]);
    IndexGrid.Cells[2,1]:=floatToStr(Medium.RefractiveIndex[ns]);
    IndexGrid.Cells[3,1]:=floatToStr(Medium.RefractiveIndex[nr]);
    IndexGrid.Cells[4,1]:=floatToStr(Medium.RefractiveIndex[nC]);
    IndexGrid.Cells[5,1]:=floatToStr(Medium.RefractiveIndex[nd]);
    IndexGrid.Cells[6,1]:=floatToStr(Medium.RefractiveIndex[ne]);
    IndexGrid.Cells[7,1]:=floatToStr(Medium.RefractiveIndex[nF]);
    IndexGrid.Cells[8,1]:=floatToStr(Medium.RefractiveIndex[ng]);
    IndexGrid.Cells[9,1]:=floatToStr(Medium.RefractiveIndex[nh]);
    IndexGrid.Cells[10,1]:=floatToStr(Medium.RefractiveIndex[ni]);
  end;


  if ( DataGridForm.FlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
  end;

  FormPOPS.DataIsChanged;
  GlassDataForm.Visible:=False;
end;



end.
