unit ScalingBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, StdCtrls;
type
  TScalingForm = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
   
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  ScalingForm: TScalingForm;

implementation

uses UnitedData;

{$R *.dfm}

procedure TScalingForm.Button1Click(Sender: TObject);
var
  InputString:string;
  aNewFocalLength: extended;
  aScale: extended;
  i,j:integer;
 
  
begin
  InputString:=InputBox(' ',']̏œ_́H',FloatToStr( OpticalSystem.FocalLength[nd] ) );
  aNewFocalLength:=StrToFloat(InputString);
  aScale:=aNewFocalLength / OpticalSystem.FocalLength[nd];

  for i:=1 to MaxOptSurface do begin
    OpticalSystem.OpticalSurface[i].Curvature:=
              OpticalSystem.OpticalSurface[i].Curvature / aScale;
    if OpticalSystem.OpticalSurface[i].Curvature=0 then begin
      OpticalSystem.OpticalSurface[i].Radius:=FLAT;
    end else begin
      OpticalSystem.OpticalSurface[i].Radius:=1 / OpticalSystem.OpticalSurface[i].Curvature;
    end;
    OpticalSystem.OpticalSurface[i].Diameter:=OpticalSystem.OpticalSurface[i].Diameter*aScale;
  end;

  for i:=0 to MaxOptSurface do begin
     OpticalSystem.OpticalMedium[i].Distance:=
              OpticalSystem.OpticalMedium[i].Distance*aScale;
  end;

  for i:=1 to MaxOptSurface do begin
    for j:=1 to  MaxCoefficient do begin
      OpticalSystem.OpticalSurface[i].AsphericalCoefficient[j]:=
      OpticalSystem.OpticalSurface[i].AsphericalCoefficient[j]/(pow(aScale,(2*j-1)));
    end;
  end;

  OpticalSystem.FocusPlane.Curvature:=OpticalSystem.FocusPlane.Curvature/aScale;
  if OpticalSystem.FocusPlane.Curvature=0 then begin
    OpticalSystem.FocusPlane.Radius:=FLAT;
  end else begin
    OpticalSystem.FocusPlane.Radius:=1/OpticalSystem.FocusPlane.Curvature;
  end;

  OpticalSystem.FocusPlane.Diameter:=OpticalSystem.FocusPlane.Diameter*aScale;

// f[^̕\  ߎǐՂB
//\̃{^ď B

  UnitedDataForm.BitBtn1.Click;

  UnitedDataForm.BitBtn18.Click;


  Edit1.Text:=InputString;
  
end;

procedure TScalingForm.FormCreate(Sender: TObject);
begin
  Edit1.Text:=FloatToStr(OpticalSystem.FocalLength[nd]);
  self.Caption:='Scaling'+'/'+OpticalSystem.OpticalName;
end;

procedure TScalingForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action:=caFree;
end;



end.
