unit SpotBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, StdCtrls,
  Spin, ExtCtrls, Buttons;
const
  MaxSpotArray=33;
  MaxSpotAngle=9;
  MaxMTFAngle=9;
  Half=1/2;
  Full=2/2;
type
  TSpotForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    ntPaintBox: TPaintBox;
    nsPaintBox: TPaintBox;
    nrPaintBox: TPaintBox;
    nCPaintBox: TPaintBox;
    ndPaintBox: TPaintBox;
    Label1: TLabel;
    nePaintBox: TPaintBox;
    nFPaintBox: TPaintBox;
    ngPaintBox: TPaintBox;
    nhPaintBox: TPaintBox;
    niPaintBox: TPaintBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel2: TPanel;
    InputAngleSE: TSpinEdit;
    SpotButton: TButton;
    Label11: TLabel;
    Panel3: TPanel;
    ScaleScrollBar: TScrollBar;
    DrawButton: TButton;
    ScaleEdit: TEdit;
    AngleComboBox: TComboBox;
    AngleEdit: TEdit;
    Label12: TLabel;
    Label14: TLabel;
    Panel4: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox3: TPaintBox;
    PaintBox4: TPaintBox;
    PaintBox5: TPaintBox;
    PaintBox6: TPaintBox;
    PaintBox7: TPaintBox;
    PaintBox8: TPaintBox;
    PaintBox9: TPaintBox;
    Panel5: TPanel;
    Panel6: TPanel;
    InputAngleSE2: TSpinEdit;
    SpotButton2: TButton;
    AngleEdit2: TEdit;
    ScaleEdit2: TEdit;
    Label15: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    ProgressBar1: TProgressBar;
    TabSheet3: TTabSheet;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Label19: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    DefocusEdit3: TEdit;
    ScaleEdit3: TEdit;
    DefocusScrollBar3: TScrollBar;
    ScaleScrollBar3: TScrollBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    PaintBox10: TPaintBox;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    SpotButton3: TButton;
    DrawButton3: TButton;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Timer1: TTimer;
    Edit7: TEdit;
    Label31: TLabel;
    Edit8: TEdit;
    Edit12: TEdit;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    AngleComboBox2: TComboBox;
    Panel10: TPanel;
    Label36: TLabel;
    SpotComboBox: TComboBox;
    SpinButton1: TSpinButton;
    Edit13: TEdit;
    Edit14: TEdit;
    SpinButton2: TSpinButton;
    DefocusScrollBar2: TScrollBar;
    DefocusEdit2: TEdit;
    Label16: TLabel;
    DefocusScrollBar: TScrollBar;
    DefocusEdit: TEdit;
    Label13: TLabel;
    PBReDrawControler: TPaintBox;
    PBReDrawControler2: TPaintBox;
    Panel11: TPanel;
    BitBtn1: TBitBtn;
    Edit15: TEdit;
    Label37: TLabel;
    BitBtn2: TBitBtn;
    Button5: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    Image6: TImage;
    Image7: TImage;
    Image8: TImage;
    Image9: TImage;
    ndImage: TImage;
    nCImage: TImage;
    nrImage: TImage;
    nsImage: TImage;
    ntImage: TImage;
    neImage: TImage;
    nFImage: TImage;
    ngImage: TImage;
    nhImage: TImage;
    niImage: TImage;
    Image10: TImage;
    ScaleScrollBar2: TScrollBar;
    Button6: TButton;
    Button7: TButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure InputAngleSEChange(Sender: TObject);
    procedure DefocusScrollBarChange(Sender: TObject);
    procedure SpotButtonClick(Sender: TObject);
    procedure AngleComboBoxChange(Sender: TObject);
    procedure ScaleScrollBarChange(Sender: TObject);
    procedure DrawButtonClick(Sender: TObject);
    procedure InputAngleSE2Change(Sender: TObject);
    procedure DefocusScrollBar2Change(Sender: TObject);
    procedure SpotButton2Click(Sender: TObject);
    procedure AngleComboBox2Change(Sender: TObject);
    procedure ScaleScrollBar2Change(Sender: TObject);
    procedure DefocusScrollBar3Change(Sender: TObject);
    procedure ScaleScrollBar3Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpotButton3Click(Sender: TObject);
    procedure DrawButton3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure SpotComboBoxChange(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure PBReDrawControlerPaint(Sender: TObject);
    procedure PBReDrawControler2Paint(Sender: TObject);
    procedure PaintBox10Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScaleEdit2Change(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);

    procedure PageControl1Change(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);


  private
    { Private 錾 }
 //   Ray,FinalRay:TD3Ray;

    InputAngle:extended;
    InputAngleDecimal:extended;
    AngleNo:byte;
    Defocus:extended;
    GraphScale:extended;
    DefocusFinit:extended;
    GraphScaleFinit:extended;

    SpotPointY: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    SpotPointZ: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;

    MTFSpotPointY: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFSpotPointZ: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;

    Rt10: array[1..MaxMTFAngle] of extended;
    Rs10: array[1..MaxMTFAngle] of extended;
    Rt30: array[1..MaxMTFAngle] of extended;
    Rs30: array[1..MaxMTFAngle] of extended;
    V10: extended;
    V30: extended;

    RayCounter: array[1..MaxMTFAngle] of integer;
//    TestRayCounter: array[1..MaxMTFAngle] of integer;

    FinalSurfaceAX: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    FinalSurfaceAY: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    FinalSurfaceAZ: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    FinalSurfaceDIX: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    FinalSurfaceDIY: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    FinalSurfaceDIZ: array[1..MaxSpotAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;

    MTFFinalSurfaceAX: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFFinalSurfaceAY: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFFinalSurfaceAZ: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFFinalSurfaceDIX: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFFinalSurfaceDIY: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;
    MTFFinalSurfaceDIZ: array[1..MaxMTFAngle,nd..nt,1..(MaxSpotArray*MaxSpotArray)] of extended;

    ObjectPointX: extended;
    ObjectPointY: extended;
    ObjectPointZ: extended;
    clNt,clNs,clNr,clNC,clNd,clNe,clNF,clNg,clNh,clNi :Tcolor;

  //  FlagDraw:boolean;
  
    procedure Initialize(Sender: TObject);
    procedure FinalPointCulculate;
    procedure FinalPointFinitCulculate;
    procedure CulculateMTF;
    procedure finalPointForMTFCulculate;
    procedure DrawCompositSpot;
    procedure CulculateSpot;
    procedure DrawCompositSpotOnImage;
    procedure DrawOnPaintBox;
    procedure DrawSpotFinitOnPaintBox;
    procedure DrawSeparatSpot;
  public
    { Public 錾 }
    ImageHight:extended;
    ImageHightHarf:extended;

    function GetRt10(index:integer):extended;
    function GetRs10(index:integer):extended;
    function GetRt30(index:integer):extended;
    function GetRs30(index:integer):extended;
    function GetSpotPointY(index:integer; index2:TSpectru; index3:integer):extended;
    function GetSpotPointZ(index:integer; index2:TSpectru; index3:integer):extended;
    procedure CulSpot;

  end;

var
  SpotForm: TSpotForm;
  MaxSpotNumber: integer;

implementation

uses DataGrid, D3VewBrowser, PlanBrowser, ParAxialForm, MTF, SpotCorrection;


{$R *.dfm}

function TSpotForm.GetSpotPointY(index:integer; index2:TSpectru; index3:integer):extended;
begin
  result:=SpotPointY[index,index2,index3];
end;

function TSpotForm.GetSpotPointZ(index:integer; index2:TSpectru; index3:integer):extended;
begin
  result:=SpotPointZ[index,index2,index3];
end;

procedure TSpotForm.CulSpot;
begin
 self.CulculateSpot;
end;

function TSpotForm.GetRt10(index:integer):extended;
begin
  result:= Rt10[index];
end;
function TSpotForm.GetRs10(index:integer):extended;
begin
  result:= Rs10[index];
end;
function TSpotForm.GetRt30(index:integer):extended;
begin
  result:= Rt30[index];
end;
function TSpotForm.GetRs30(index:integer):extended;
begin
  result:= Rs30[index];
end;


procedure TSpotForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// Action:=caFree;
  SpotForm.Visible:=False;
end;

procedure TSpotForm.Initialize(Sender: TObject);
var
  j,k:integer;
  n:TSpectru;
begin
  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=$B0FFFF; //F
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$82004B;

  MaxSpotNumber:=15;

  InputAngle:=0;
  InputAngleSE2.Value:=0;

  Defocus:=0;
  InputAngleDecimal:=0;
  Edit13.Text:='0.0';
  Edit14.Text:='0.0';

  for j:=1 to MaxSpotAngle do begin
    for n:=nd to nt do begin
      for k:=1 to MaxSpotArray*MaxSpotArray do begin
        SpotPointY[j,n,k]:=0;
        SpotPointZ[j,n,k]:=0;
        FinalSurfaceAX[j,n,k]:=0;
        FinalSurfaceAY[j,n,k]:=0;
        FinalSurfaceAZ[j,n,k]:=0;
        FinalSurfaceDIX[j,n,k]:=1;
        FinalSurfaceDIY[j,n,k]:=0;
        FinalSurfaceDIZ[j,n,k]:=0;
      end;
    end;
  end;

  for j:=1 to MaxMTFAngle do begin
    for n:=nd to nt do begin
      for k:=1 to MaxSpotArray*MaxSpotArray do begin
        MTFSpotPointY[j,n,k]:=0;
        MTFSpotPointZ[j,n,k]:=0;
      end;
    end;
    Rt10[j]:=0;
    Rs10[j]:=0;
    Rt30[j]:=0;
    Rs30[j]:=0;
    RayCounter[j]:=0;
  end;

  ObjectPointX:=0;
  ObjectPointY:=0;
  ObjectPointZ:=0;
  DefocusFinit:=0;
  GraphScaleFinit:=0;

  V10:=10;
  V30:=30;

  if OpticalSystem.ObjectDistance<=-1.0e100 then begin
    Edit3.Text:='INFINITY';
  end else begin
    Edit3.Text:=FloatToStr(OpticalSystem.ObjectDistance);
  end;
  Edit4.Text:=FloatToStr(ObjectPointX);
  Edit5.Text:=FloatToStr(ObjectPointY);
  Edit6.Text:=FloatToStr(ObjectPointZ);


  SpotComboBox.ItemIndex:=2;


  AngleComboBox2Change(Sender);
  ScaleScrollBar2Change(Sender);
  GraphScale:=ScaleScrollBar2.Position/1000;
  ScaleEdit2.Text:=FloatToStr(GraphScale);
 // DefocusScrollBar2Change(Sender); //ŃX|bgvZĂ̂ŋNƃnOB

//  ScaleScrollBar3Change(Sender);
  GraphScaleFinit:=ScaleScrollBar3.Position/1000;
  ScaleEdit3.Text:=FloatToStr(GraphScaleFinit);
//  DefocusScrollBar3Change(Sender);

  AngleComboBoxChange(Sender);
//  ScaleScrollBarChange(Sender);
  GraphScale:=ScaleScrollBar.Position/1000;
  ScaleEdit.Text:=FloatToStr(GraphScale);
//  DefocusScrollBarChange(Sender);

  Edit15.Text:=FloatToStrF(OpticalSystem.FocusPlaneDistance,ffGeneral,10,10);
  self.Caption:='Spot'+'/'+OpticalSystem.OpticalName;
end;

procedure TSpotForm.InputAngleSEChange(Sender: TObject);
begin
   InputAngle:=InputAngleSE.Value+InputAngleDecimal;
   InputAngleSE2.Value:=InputAngleSE.Value;
end;

procedure TSpotForm.DefocusScrollBarChange(Sender: TObject);
begin

  Defocus:=DefocusScrollBar.Position/100;
  DefocusEdit.Text:=FloatToStr(Defocus);
  DefocusScrollBar2.Position:=DefocusScrollBar.Position;
  DefocusEdit2.Text:=DefocusEdit.Text;
  DefocusScrollBar2Change(Sender);
  DrawButtonClick(Sender);

end;

procedure TSpotForm.SpotButtonClick(Sender: TObject);
begin
  SpotButton2Click(Sender);
end;


procedure TSpotForm.AngleComboBoxChange(Sender: TObject);
begin

 if AngleComboBox.Text='Ox' then
   AngleNo:=1
   else if AngleComboBox.Text='Ԋpx' then
     AngleNo:=2
     else if AngleComboBox.Text='őpx' then
       AngleNo:=3
       else begin
         AngleNo:=1;
         AngleComboBox.Text:='Ox';
       end;

 if AngleNo=1 then begin
    AngleEdit.Text:='0';
 end else begin
   AngleEdit.Text:=FloatToStr(InputAngle*( (AngleNo-1) / 2 ) );
 end;

 DrawButtonClick(Sender);

end;


procedure TSpotForm.ScaleScrollBarChange(Sender: TObject);
begin
  GraphScale:=ScaleScrollBar.Position/1000;
  ScaleEdit.Text:=FloatToStr(GraphScale);
  ScaleScrollBar2.Position:=ScaleScrollBar.Position;
  ScaleEdit2.Text:=FloatToStr(GraphScale);
  DrawButtonClick(Sender);
end;

procedure TSpotForm.DrawOnPaintBox;
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aPaintBox:TPaintBox;
  aSpace:word;
begin
   aPaintBox:=ndPaintBox;

   for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aPaintBox:=ntPaintBox;
       ns : aPaintBox:=nsPaintBox;
       nr : aPaintBox:=nrPaintBox;
       nC : aPaintBox:=nCPaintBox;
       nd : aPaintBox:=ndPaintBox;
       ne : aPaintBox:=nePaintBox;
       nF : aPaintBox:=nFPaintBox;
       ng : aPaintBox:=ngPaintBox;
       nh : aPaintBox:=nhPaintBox;
       ni : aPaintBox:=niPaintBox;
     end;

     aSpace:=2;
     aDodScale:=GraphScale/ (aPaintBox.width - aSpace*2);
     aCenterX:=aPaintBox.width div 2;
     aCenterY:=aPaintBox.height div 2;
     aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

     aPaintBox.Canvas.Pen.Color:=clBlack;
     aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);
     aPaintBox.Canvas.Pen.Color:=clSilver;
     aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, aSpace );
     aPaintBox.Canvas.LineTo( aPaintBox.width div 2, aPaintBox.height-aSpace  );
     aPaintBox.Canvas.MoveTo( aSpace, aPaintBox.height div 2 );
     aPaintBox.Canvas.LineTo( aPaintBox.width-aSpace, aPaintBox.height div 2  );

     case n of
       nt : aPaintBox.Canvas.Pen.Color:=clNt;
       ns : aPaintBox.Canvas.Pen.Color:=clNs;
       nr : aPaintBox.Canvas.Pen.Color:=clNr;
       nC : aPaintBox.Canvas.Pen.Color:=clNC;
       nd : aPaintBox.Canvas.Pen.Color:=clNd;
       ne : aPaintBox.Canvas.Pen.Color:=clNe;
       nF : aPaintBox.Canvas.Pen.Color:=clNF;
       ng : aPaintBox.Canvas.Pen.Color:=clNg;
       nh : aPaintBox.Canvas.Pen.Color:=clNh;
       ni : aPaintBox.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
      {if k>60 then aPaintBox.Canvas.Pen.Color:=clBlack;}
       if SpotPointY[AngleNo,n,k]<>NULL then begin

         aDodPointX:=aCenterX
          -trunc((SpotPointZ[AngleNo,nd,aPrincipalRay] - SpotPointZ[AngleNo,n,k]) / aDodScale);
         aDodPointY:=aCenterY
          +trunc((SpotPointY[AngleNo,nd,aPrincipalRay] - SpotPointY[AngleNo,n,k]) / aDodScale);

         aPaintBox.Canvas.MoveTo(aDodPointX,aDodPointY);
         aPaintBox.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );

       end;

     end;

   end;

end;

procedure TSpotForm.DrawSeparatSpot;
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aSpotImage:TImage;
  aSpace:word;
begin

// if OpticalSystem.ObjectDistance>-1.0e10 then
//   exit;


     ntImage.Canvas.brush.Color:=clGray;
     ntImage.Picture.Bitmap.Canvas.fillRect(ntImage.Canvas.clipRect) ;

     nsImage.Canvas.brush.Color:=clGray;
     nsImage.Picture.Bitmap.Canvas.fillRect(nsImage.Canvas.clipRect) ;

     nrImage.Canvas.brush.Color:=clGray;
     nrImage.Picture.Bitmap.Canvas.fillRect(nrImage.Canvas.clipRect) ;

     nCImage.Canvas.brush.Color:=clGray;
     nCImage.Picture.Bitmap.Canvas.fillRect(nCImage.Canvas.clipRect) ;

     neImage.Canvas.brush.Color:=clGray;
     neImage.Picture.Bitmap.Canvas.fillRect(neImage.Canvas.clipRect) ;

     nFImage.Canvas.brush.Color:=clGray;
     nFImage.Picture.Bitmap.Canvas.fillRect(nFImage.Canvas.clipRect) ;

     ngImage.Canvas.brush.Color:=clGray;
     ngImage.Picture.Bitmap.Canvas.fillRect(ngImage.Canvas.clipRect) ;

     nhImage.Canvas.brush.Color:=clGray;
     nhImage.Picture.Bitmap.Canvas.fillRect(nhImage.Canvas.clipRect) ;

     niImage.Canvas.brush.Color:=clGray;
     niImage.Picture.Bitmap.Canvas.fillRect(niImage.Canvas.clipRect) ;


   for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aSpotImage:=ntImage;
       ns : aSpotImage:=nsImage;
       nr : aSpotImage:=nrImage;
       nC : aSpotImage:=nCImage;
       nd : aSpotImage:=ndImage;
       ne : aSpotImage:=neImage;
       nF : aSpotImage:=nFImage;
       ng : aSpotImage:=ngImage;
       nh : aSpotImage:=nhImage;
       ni : aSpotImage:=niImage;
     end;

     aSpotImage.Canvas.brush.Color:=clGray;
     aSpotImage.Picture.Bitmap.Canvas.fillRect(aSpotImage.Canvas.clipRect) ;


     aSpace:=2;
     aDodScale:=GraphScale/ (aSpotImage.width - aSpace*2);
     aCenterX:=aSpotImage.width div 2;
     aCenterY:=aSpotImage.height div 2;
     aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

     aSpotImage.Canvas.Pen.Color:=clBlack;
     aSpotImage.Canvas.Rectangle(0,0,aSpotImage.width,aSpotImage.height);
     aSpotImage.Canvas.Pen.Color:=clSilver;
     aSpotImage.Canvas.MoveTo( aSpotImage.width div 2, aSpace );
     aSpotImage.Canvas.LineTo( aSpotImage.width div 2, aSpotImage.height-aSpace  );
     aSpotImage.Canvas.MoveTo( aSpace, aSpotImage.height div 2 );
     aSpotImage.Canvas.LineTo( aSpotImage.width-aSpace, aSpotImage.height div 2  );

     case n of
       nt : aSpotImage.Canvas.Pen.Color:=clNt;
       ns : aSpotImage.Canvas.Pen.Color:=clNs;
       nr : aSpotImage.Canvas.Pen.Color:=clNr;
       nC : aSpotImage.Canvas.Pen.Color:=clNC;
       nd : aSpotImage.Canvas.Pen.Color:=clNd;
       ne : aSpotImage.Canvas.Pen.Color:=clNe;
       nF : aSpotImage.Canvas.Pen.Color:=clNF;
       ng : aSpotImage.Canvas.Pen.Color:=clNg;
       nh : aSpotImage.Canvas.Pen.Color:=clNh;
       ni : aSpotImage.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
      {if k>60 then aSpotImage.Canvas.Pen.Color:=clBlack;}
       if SpotPointY[AngleNo,n,k]<>NULL then begin

         aDodPointX:=aCenterX
          -trunc((SpotPointZ[AngleNo,nd,aPrincipalRay] - SpotPointZ[AngleNo,n,k]) / aDodScale);
         aDodPointY:=aCenterY
          +trunc((SpotPointY[AngleNo,nd,aPrincipalRay] - SpotPointY[AngleNo,n,k]) / aDodScale);

         aSpotImage.Canvas.MoveTo(aDodPointX,aDodPointY);
         aSpotImage.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );

       end;

     end;

   end;

end;


procedure TSpotForm.DrawButtonClick(Sender: TObject);

begin
 self.DrawSeparatSpot;
end;


procedure TSpotForm.InputAngleSE2Change(Sender: TObject);
begin
  InputAngle:=InputAngleSE2.Value+InputAngleDecimal;
  InPutAngleSE.Value:=InputAngleSE2.Value;
end;

procedure TSpotForm.DefocusScrollBar2Change(Sender: TObject);
begin


Screen.Cursor:=crNo;
  Defocus:=DefocusScrollBar2.Position/100;
  DefocusEdit2.Text:=FloatToStr(Defocus);

  SpotButton2.Click;

Screen.Cursor:=crDefault;

end;

procedure TSpotForm.FinalPointCulculate;
var
    n:TSpectru;
    j,k:integer;
    aFinalRay:TD3Ray;

begin

aFinalRay:=TD3Ray.Create;

try

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
  FinalOpt.EntrancePupil:=(OpticalSystem.FocusPlaneDistance{BackFocus[nd]} + defocus)*-1;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


  for j:=1 to MaxSpotAngle do begin

    for n:=nd to OpticalSystem.LastSpectru do begin
      for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin

        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=FinalSurfaceAX[j,n,k];
        aFinalRay.ay:=FinalSurfaceAY[j,n,k];
        aFinalRay.az:=FinalSurfaceAZ[j,n,k];
        aFinalRay.dxi:=FinalSurfaceDIX[j,n,k];
        aFinalRay.dyi:=FinalSurfaceDIY[j,n,k];
        aFinalRay.dzi:=FinalSurfaceDIZ[j,n,k];

        if aFinalRay.ay<>NULL then begin
          FinalOpt.RayTraceInAspherical(aFinalRay ,n);
          SpotPointY[j,n,k]:=aFinalRay.ay;
          SpotPointZ[j,n,k]:=aFinalRay.az;

        end else begin
          SpotPointY[j,n,k]:=NULL;
          SpotPointZ[j,n,k]:=NULL;
        end;


      end;
    end;
  end;
finally
  aFinalRay.Free;
end;
end;


procedure TSpotForm.CulculateSpot;
var
    aDr,  aStep, aDxi,aDyi, aDzi,
    anAngle:Extended;
    aRay:TD3Ray;
    n:TSpectru;
    j,k:integer;
    aStack: boolean;
begin

if OpticalSystem.ObjectDistance>-1.0e10 then begin
    Application.MessageBox('_LłAL_̃y[WŌvZĂB', '', MB_OK);
end else begin

  aStack:=true;

  Screen.Cursor:=crHourGlass;

  aRay:=TD3Ray.create;

  try

    if OpticalSystem.EffectiveAperture<>0 then
      aDr:=OpticalSystem.EffectiveAperture
    else
      aDr:=(OpticalSystem.OpticalSurface[1].diameter);

    aStep:=aDr / (MaxSpotNumber - 1);


    for j:=1 to MaxSpotAngle do begin
      ProgressBar1.StepIt;
      case j of
        1:anAngle:=degreeToRadian(0);

        2:anAngle:=degreeToRadian(-1*InputAngle * (Half));
        3:anAngle:=degreeToRadian(-1*InputAngle * (Full));

        4:anAngle:=degreeToRadian(InputAngle * (Half));
        5:anAngle:=degreeToRadian(InputAngle * (Full));

        6:anAngle:=degreeToRadian(-1*InputAngle * (Half));
        7:anAngle:=degreeToRadian(-1*InputAngle * (Full));

        8:anAngle:=degreeToRadian(InputAngle * (Half));
        9:anAngle:=degreeToRadian(InputAngle * (Full));
      else
       anAngle:=degreeToRadian(0);
      end;

      if j<=5 then begin
        aDxi:= 1/( sqrt( 1+(tan(anAngle)*tan(anAngle)) ) )  ;
        aDyi:= -1*aDxi*tan(anAngle) ;
        aDzi:=0;
      end else begin
        aDxi:= 1/( sqrt( 1+(tan(anAngle)*tan(anAngle)) ) )  ;
        aDyi:=0 ;
        aDzi:= -1*aDxi*tan(anAngle) ;
      end;

      for n:=nd to OpticalSystem.LastSpectru do begin
        for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin
          aRay.initialize;
          aRay.qntp:=OpticalSystem.EntrancePupil;  {entrancePupil.}
          aRay.ax:=0;
          aRay.ay:=( (aDr / -2) + ( aStep * int((k - 1) div MaxSpotNumber) )  );
          aRay.az:=( (aDr / -2) + ( aStep * int((k - 1) mod MaxSpotNumber) )  );
          aRay.dxi:=aDxi;
          aRay.dyi:=aDyi;
          aRay.dzi:=aDzi;

          if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
            aStack:=OpticalSystem.RayCheckSwitch;
            OpticalSystem.RayCheckSwitch:=False;
          end;

          OpticalSystem.CenterBrockSwitch:=True;
          OpticalSystem.RayTraceInAspherical(aRay, n);
          OpticalSystem.CenterBrockSwitch:=False;

          if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
            OpticalSystem.RayCheckSwitch:=aStack;
          end;

          FinalSurfaceAX[j,n,k]:=aRay.ax;
          FinalSurfaceAY[j,n,k]:=aRay.ay;
          FinalSurfaceAZ[j,n,k]:=aRay.az;
          FinalSurfaceDIX[j,n,k]:=aRay.Dxi;
          FinalSurfaceDIY[j,n,k]:=aRay.Dyi;
          FinalSurfaceDIZ[j,n,k]:=aRay.Dzi;

        end;
      end;
    end;

    self.finalPointCulculate;



  finally
    aRay.Free;
    Screen.Cursor:=crDefault;
  end;

    self.CulculateMTF;

end; //L_Ή[v

end;


procedure TSpotForm.SpotButton2Click(Sender: TObject);
var
   aStartTime,  aCulTime: TDateTime;
   hour,min,sec,msec:word;
begin


  aStartTime:=Time;

  self.CulculateSpot;

  self.DrawCompositSpotOnImage;

  self.DrawSeparatSpot; //\̕`

  MTFForm.Button2Click(sender);

  aCulTime:=Time - aStartTime;
  decodetime(aCulTime,hour,min,sec,msec);
  Edit7.Text:=inttostr(sec)+'.'+inttostr(msec)+'"';


end;



procedure TSpotForm.AngleComboBox2Change(Sender: TObject);
var
  aSelectAngleNumber:integer;
begin
 aSelectAngleNumber:=1;

 if AngleComboBox2.Text='Parallel' then aSelectAngleNumber:=1;
 if AngleComboBox2.Text='1/2' then aSelectAngleNumber:=2;
 if AngleComboBox2.Text='Full' then aSelectAngleNumber:=3;

 if aSelectAngleNumber=1 then begin
    AngleEdit2.Text:='0'
 end else begin
   AngleEdit2.Text:=FloatToStr(InputAngle*( (aSelectAngleNumber-1) / 2 ) );
 end;


end;


procedure TSpotForm.ScaleScrollBar2Change(Sender: TObject);

begin
    GraphScale:=ScaleScrollBar2.Position/1000;
    ScaleEdit2.Text:=FloatToStr(GraphScale);
    ScaleScrollBar.Position:=ScaleScrollBar2.Position; //ň`悵Ă
    ScaleEdit.Text:=FloatToStr(GraphScale);
    self.DrawCompositSpotOnImage
end;



procedure TSpotForm.DrawCompositSpot;
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aPaintBox:TPaintBox;
  aSpace:word;
  j:integer;
  aNowDotColor:TColor;
  aPenColorBuckUp:TColor;
  aDrawPenColor:Tcolor;
begin
    aPaintBox:=PaintBox1;

  for j:=1 to MaxSpotAngle do begin


    case j of

       1 : aPaintBox:=PaintBox1;
       2 : aPaintBox:=PaintBox2;
       3 : aPaintBox:=PaintBox3;
       4 : aPaintBox:=PaintBox4;
       5 : aPaintBox:=PaintBox5;
       6 : aPaintBox:=PaintBox6;
       7 : aPaintBox:=PaintBox7;
       8 : aPaintBox:=PaintBox8;
       9 : aPaintBox:=PaintBox9;

    end;

    aSpace:=2;
    aDodScale:=GraphScale/ (aPaintBox.width - aSpace*2);
    aCenterX:=aPaintBox.width div 2;
    aCenterY:=aPaintBox.height div 2;
    aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

    aPaintBox.Canvas.Pen.Color:=clBlack;
    aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);
    aPaintBox.Canvas.Pen.Color:=clSilver;
    aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, aSpace );
    aPaintBox.Canvas.LineTo( aPaintBox.width div 2, aPaintBox.height-aSpace  );
    aPaintBox.Canvas.MoveTo( aSpace, aPaintBox.height div 2 );
    aPaintBox.Canvas.LineTo( aPaintBox.width-aSpace, aPaintBox.height div 2  );

    for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aPaintBox.Canvas.Pen.Color:=clNt;
       ns : aPaintBox.Canvas.Pen.Color:=clNs;
       nr : aPaintBox.Canvas.Pen.Color:=clNr;
       nC : aPaintBox.Canvas.Pen.Color:=clNC;
       nd : aPaintBox.Canvas.Pen.Color:=clNd;
       ne : aPaintBox.Canvas.Pen.Color:=clNe;
       nF : aPaintBox.Canvas.Pen.Color:=clNF;
       ng : aPaintBox.Canvas.Pen.Color:=clNg;
       nh : aPaintBox.Canvas.Pen.Color:=clNh;
       ni : aPaintBox.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
       if SpotPointY[j,n,k]<>NULL then begin
         aDodPointX:=aCenterX -trunc((SpotPointZ[j,nd,aPrincipalRay] - SpotPointZ[j,n,k]) / aDodScale);
         aDodPointY:=aCenterY +trunc((SpotPointY[j,nd,aPrincipalRay] - SpotPointY[j,n,k]) / aDodScale);

         aPenColorBuckUp:=aPaintBox.Canvas.Pen.Color;

         aNowDotColor:=aPaintBox.Canvas.Pixels[aDodPointX,aDodPointY];
         if aNowDotColor=clGray then begin

         end else begin
           aDrawPenColor:=aNowDotColor or aPaintBox.Canvas.Pen.Color;
           aPaintBox.Canvas.Pen.Color:=aDrawPenColor;
         end;
         aPaintBox.Canvas.MoveTo(aDodPointX,aDodPointY);
         aPaintBox.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );
         aPaintBox.Canvas.Pen.Color:= aPenColorBuckUp;
       end;
     end;

    end;

  end;


  Edit1.Text:=floatToStrF(SpotPointY[2,nd,aPrincipalRay],ffGeneral,5,4);
  Edit2.Text:=floatToStrF(SpotPointY[3,nd,aPrincipalRay],ffGeneral,5,4);
  Edit8.Text:=floatToStr(InputAngle* (Half) );
  Edit12.Text:=floatToStr(InputAngle* (Full) );

  ImageHight:=SpotPointY[3,nd,aPrincipalRay];
  ImageHightHarf:=SpotPointY[2,nd,aPrincipalRay];

end;




procedure TSpotForm.DefocusScrollBar3Change(Sender: TObject);
begin
  DefocusFinit:=DefocusScrollBar3.Position/100;
  DefocusEdit3.Text:=FloatToStr(DefocusFinit);
  self.FinalPointFinitCulculate;
  SpotButton3Click(Sender);
end;

procedure TSpotForm.ScaleScrollBar3Change(Sender: TObject);
begin

  GraphScaleFinit:=ScaleScrollBar3.Position/1000;
  ScaleEdit3.Text:=FloatToStr(GraphScaleFinit);

  DrawButton3Click(Sender);

end;

procedure TSpotForm.FinalPointFinitCulculate;
var
    n:TSpectru;
    k:integer;
    aFinalRay:TD3Ray;

begin

aFinalRay:=TD3Ray.Create;

try

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
  FinalOpt.EntrancePupil:=(OpticalSystem.FocusPlaneDistance{BackFocus[nd]} + defocusFinit)*-1;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;

    for n:=nd to OpticalSystem.LastSpectru do begin
      for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin

        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=FinalSurfaceAX[1,n,k];
        aFinalRay.ay:=FinalSurfaceAY[1,n,k];
        aFinalRay.az:=FinalSurfaceAZ[1,n,k];
        aFinalRay.dxi:=FinalSurfaceDIX[1,n,k];
        aFinalRay.dyi:=FinalSurfaceDIY[1,n,k];
        aFinalRay.dzi:=FinalSurfaceDIZ[1,n,k];

        if aFinalRay.ay<>NULL then begin
          FinalOpt.RayTraceInAspherical(aFinalRay ,n);
          SpotPointY[1,n,k]:=aFinalRay.ay;
          SpotPointZ[1,n,k]:=aFinalRay.az;
        end else begin
          SpotPointY[1,n,k]:=NULL;
          SpotPointZ[1,n,k]:=NULL;
        end;


      end;
    end;

finally
  aFinalRay.Free;
end;
end;


procedure TSpotForm.Button1Click(Sender: TObject);
var inputString:string;
begin
  inputString:=InputBox('ObjectDistanceInput','Object distance',FloatToStr(OpticalSystem.Objectdistance) );
  OpticalSystem.ObjectDistance:=StrToFloat(inputString);

  D3Vew.FinitRayPointX:=OpticalSystem.ObjectDistance;
  PlanForm.FinitRayPointX:=OpticalSystem.ObjectDistance;

  if OpticalSystem.ObjectDistance<=-1.0e100 then begin
    Edit3.Text:='INFINITY';
  end else begin
    Edit3.Text:=FloatToStr(OpticalSystem.ObjectDistance);
  end;

  if (DataGridForm.GetFlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
    DataGridForm.BitBtn2.Click;
  end;
  DataGridForm.BitBtn3.Click;

  FormPOPS.DataIsChanged;
  ParAxialDataForm.BitBtn1.Click;
  
end;

procedure TSpotForm.SpotButton3Click(Sender: TObject);
var aRay,aFinalRay:TD3Ray;
    aDr,  aStep,
    aObex, aObey, aObez, aTobei, aTobe:Extended;
    n:TSpectru;
    k:integer;
    aStack: boolean;
begin
  if OpticalSystem.ObjectDistance<=-1.0e10 then begin
    Application.MessageBox('_łB', '', MB_OK);
  end else begin

    aStack:=true;

    Screen.Cursor:=crHourGlass;

    aRay:=TD3Ray.create;
    aFinalRay:=TD3Ray.create;
    try

       FinalOpt.Initialize;
       FinalOpt.TotalSurfaceNumber:=1;
       FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
       FinalOpt.EntrancePupil:=(OpticalSystem.FocusPlaneDistance{BackFocus[nd]}
                          + DefocusFinit)*-1;
       FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
       FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
       FinalOpt.RayCheckSwitch:=False;

       if OpticalSystem.EffectiveAperture<>0 then
         aDr:=OpticalSystem.EffectiveAperture
       else
         aDr:=(OpticalSystem.OpticalSurface[1].diameter);
         {"Sukosi Tiisaku Siteiru"}
       aStep:=aDr / (MaxSpotNumber - 1);

       for n:=nd to OpticalSystem.LastSpectru do begin
         for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin

           aRay.initialize;
           aRay.qntp:=OpticalSystem.EntrancePupil;
           aRay.ax:=0;
           aRay.ay:=( (aDr / -2) + ( aStep * int((k - 1) div MaxSpotNumber) )  );
           aRay.az:=( (aDr / -2) + ( aStep * int((k - 1) mod MaxSpotNumber) )  );

           aObex:=aRay.ax - (OpticalSystem.ObjectDistance + ObjectPointX) + OpticalSystem.EntrancePupil;
           aObey:=aRay.ay - ObjectPointY;
           aObez:=aRay.az - ObjectPointZ;

           aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );

           if aObex<0 then
             aTobe:=-1*aTobe;

           aTobei:=1 / aTobe;

           aRay.dxi:=aObex * aTobei;
           aRay.dyi:=aObey * aTobei;
           aRay.dzi:=aObez * aTobei;

           if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
             aStack:=OpticalSystem.RayCheckSwitch;
             OpticalSystem.RayCheckSwitch:=False;
           end;
           OpticalSystem.RayTraceInAspherical(aRay, n);
           if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
             OpticalSystem.RayCheckSwitch:=aStack;
           end;


           aFinalRay.Initialize;
           aFinalRay.qntp:=FinalOpt.EntrancePupil;

           aFinalRay.ax:=aRay.ax;
           aFinalRay.ay:=aRay.ay;
           aFinalRay.az:=aRay.az;
           aFinalRay.dxi:=aRay.dxi;
           aFinalRay.dyi:=aRay.dyi;
           aFinalRay.dzi:=aRay.dzi;

           FinalSurfaceAX[1,n,k]:=aRay.ax;
           FinalSurfaceAY[1,n,k]:=aRay.ay;
           FinalSurfaceAZ[1,n,k]:=aRay.az;
           FinalSurfaceDIX[1,n,k]:=aRay.Dxi;
           FinalSurfaceDIY[1,n,k]:=aRay.Dyi;
           FinalSurfaceDIZ[1,n,k]:=aRay.Dzi;

           if aFinalRay.ay<>NULL then begin
             FinalOpt.RayTraceInAspherical(aFinalRay ,n);
             SpotPointY[1,n,k]:=aFinalRay.ay;
             SpotPointZ[1,n,k]:=aFinalRay.az;
           end else begin
             SpotPointY[1,n,k]:=NULL;
             SpotPointZ[1,n,k]:=NULL;
           end;

         end;
       end;

    finally
      aRay.Free;
      aFinalRay.Free;
      Screen.Cursor:=crDefault;
    end;
      DrawButton3.Click;

  end;

end;

procedure TSpotForm.DrawSpotFinitOnPaintBox;
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aPaintBox:TPaintBox;
  aSpace:word;
  aPenColorBuckUp:TColor;
  aNowDotColor:Tcolor;
  aDrawPenColor:Tcolor;
begin

    aPaintBox:=PaintBox10;

    aSpace:=2;
    aDodScale:=GraphScaleFinit/ (aPaintBox.width - aSpace*2);
    aCenterX:=aPaintBox.width div 2;
    aCenterY:=aPaintBox.height div 2;
    aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

    aPaintBox.Canvas.Pen.Color:=clBlack;
    aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);
    aPaintBox.Canvas.Pen.Color:=clSilver;
    aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, aSpace );
    aPaintBox.Canvas.LineTo( aPaintBox.width div 2, aPaintBox.height-aSpace  );
    aPaintBox.Canvas.MoveTo( aSpace, aPaintBox.height div 2 );
    aPaintBox.Canvas.LineTo( aPaintBox.width-aSpace, aPaintBox.height div 2  );

    for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aPaintBox.Canvas.Pen.Color:=clNt;
       ns : aPaintBox.Canvas.Pen.Color:=clNs;
       nr : aPaintBox.Canvas.Pen.Color:=clNr;
       nC : aPaintBox.Canvas.Pen.Color:=clNC;
       nd : aPaintBox.Canvas.Pen.Color:=clNd;
       ne : aPaintBox.Canvas.Pen.Color:=clNe;
       nF : aPaintBox.Canvas.Pen.Color:=clNF;
       ng : aPaintBox.Canvas.Pen.Color:=clNg;
       nh : aPaintBox.Canvas.Pen.Color:=clNh;
       ni : aPaintBox.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
       if SpotPointY[1,n,k]<>NULL then begin
         aDodPointX:=aCenterX -trunc((SpotPointZ[1,nd,aPrincipalRay] - SpotPointZ[1,n,k]) / aDodScale);
         aDodPointY:=aCenterY +trunc((SpotPointY[1,nd,aPrincipalRay] - SpotPointY[1,n,k]) / aDodScale);

         aPenColorBuckUp:=aPaintBox.Canvas.Pen.Color;
         aNowDotColor:=aPaintBox.Canvas.Pixels[aDodPointX,aDodPointY];

         if aNowDotColor=clGray then begin

         end else begin
           aDrawPenColor:=aNowDotColor or aPaintBox.Canvas.Pen.Color;
           aPaintBox.Canvas.Pen.Color:=aDrawPenColor;
         end;

         aPaintBox.Canvas.MoveTo(aDodPointX,aDodPointY);
         aPaintBox.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );
         aPaintBox.Canvas.Pen.Color:= aPenColorBuckUp;

       end;
     end;

    end;

  Edit9.Text:=floatToStrF((OpticalSystem.FocusPlaneDistance),ffGeneral,5,4);
  Edit10.Text:=floatToStrF(SpotPointY[1,nd,aPrincipalRay],ffGeneral,5,4);
  Edit11.Text:=floatToStrF(SpotPointZ[1,nd,aPrincipalRay],ffGeneral,5,4);
end;


procedure TSpotForm.DrawButton3Click(Sender: TObject);
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aSpotImage:TImage;
  aSpace:word;
  aPenColorBuckUp:TColor;
  aNowDotColor:Tcolor;
  aDrawPenColor:Tcolor;
begin

    aSpotImage:=Image10;

    aSpotImage.Canvas.brush.Color:=clGray;
    aSpotImage.Picture.Bitmap.Canvas.fillRect( aSpotImage.Canvas.clipRect) ;


    aSpace:=2;
    aDodScale:=GraphScaleFinit/ (aSpotImage.width - aSpace*2);
    aCenterX:=aSpotImage.width div 2;
    aCenterY:=aSpotImage.height div 2;
    aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

    aSpotImage.Canvas.Pen.Color:=clBlack;
    aSpotImage.Canvas.Rectangle(0,0,aSpotImage.width,aSpotImage.height);
    aSpotImage.Canvas.Pen.Color:=clSilver;
    aSpotImage.Canvas.MoveTo( aSpotImage.width div 2, aSpace );
    aSpotImage.Canvas.LineTo( aSpotImage.width div 2, aSpotImage.height-aSpace  );
    aSpotImage.Canvas.MoveTo( aSpace, aSpotImage.height div 2 );
    aSpotImage.Canvas.LineTo( aSpotImage.width-aSpace, aSpotImage.height div 2  );

    for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aSpotImage.Canvas.Pen.Color:=clNt;
       ns : aSpotImage.Canvas.Pen.Color:=clNs;
       nr : aSpotImage.Canvas.Pen.Color:=clNr;
       nC : aSpotImage.Canvas.Pen.Color:=clNC;
       nd : aSpotImage.Canvas.Pen.Color:=clNd;
       ne : aSpotImage.Canvas.Pen.Color:=clNe;
       nF : aSpotImage.Canvas.Pen.Color:=clNF;
       ng : aSpotImage.Canvas.Pen.Color:=clNg;
       nh : aSpotImage.Canvas.Pen.Color:=clNh;
       ni : aSpotImage.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
       if SpotPointY[1,n,k]<>NULL then begin
         aDodPointX:=aCenterX -trunc((SpotPointZ[1,nd,aPrincipalRay] - SpotPointZ[1,n,k]) / aDodScale);
         aDodPointY:=aCenterY +trunc((SpotPointY[1,nd,aPrincipalRay] - SpotPointY[1,n,k]) / aDodScale);

         aPenColorBuckUp:=aSpotImage.Canvas.Pen.Color;
         aNowDotColor:=aSpotImage.Canvas.Pixels[aDodPointX,aDodPointY];

         if aNowDotColor=clGray then begin

         end else begin
           aDrawPenColor:=aNowDotColor or aSpotImage.Canvas.Pen.Color;
           aSpotImage.Canvas.Pen.Color:=aDrawPenColor;
         end;

         aSpotImage.Canvas.MoveTo(aDodPointX,aDodPointY);
         aSpotImage.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );
         aSpotImage.Canvas.Pen.Color:= aPenColorBuckUp;

       end;
     end;

    end;

  Edit9.Text:=floatToStrF((OpticalSystem.FocusPlaneDistance),ffGeneral,5,4);
  Edit10.Text:=floatToStrF(SpotPointY[1,nd,aPrincipalRay],ffGeneral,5,4);
  Edit11.Text:=floatToStrF(SpotPointZ[1,nd,aPrincipalRay],ffGeneral,5,4);
end;


procedure TSpotForm.Button2Click(Sender: TObject);
var inputString:string;
begin
  inputString:=InputBox('ObjectPointX','ObjectPointX',FloatToStr(ObjectPointX) );
  ObjectPointX:=StrToFloat(inputString);
  Edit4.Text:=FloatToStr(ObjectPointX);

  D3Vew.FinitRayPointX:=OpticalSystem.ObjectDistance+ObjectPointX;
  PlanForm.FinitRayPointX:=OpticalSystem.ObjectDistance+ObjectPointX;
end;


procedure TSpotForm.Button3Click(Sender: TObject);
var inputString:string;
begin
  inputString:=InputBox('ObjectPointY','ObjectPointY',FloatToStr(ObjectPointY) );
  ObjectPointY:=StrToFloat(inputString);
  Edit5.Text:=FloatToStr(ObjectPointY);
  D3Vew.FinitRayPointY:=ObjectPointY;
  PlanForm.FinitRayPointY:=ObjectPointY;
end;


procedure TSpotForm.Button4Click(Sender: TObject);
var inputString:string;
begin
  inputString:=InputBox('ObjectPointZ','ObjectPointZ',FloatToStr(ObjectPointZ) );
  ObjectPointZ:=StrToFloat(inputString);
  Edit6.Text:=FloatToStr(ObjectPointZ);
  D3Vew.FinitRayPointZ:=ObjectPointZ;
  PlanForm.FinitRayPointZ:=ObjectPointZ;
end;

procedure TSpotForm.SpotComboBoxChange(Sender: TObject);
var
  j,k:integer;
  n:TSpectru;
begin
{  aData:=SpotComboBox.Text;
  case aData of
    49:  MaxSpotNumber:=7;
    81:  MaxSpotNumber:=9;
    121: MaxSpotNumber:=11;
    169: MaxSpotNumber:=13;
    225: MaxSpotNumber:=15;
    289: MaxSpotNumber:=17;
    361: MaxSpotNumber:=19;
    441: MaxSpotNumber:=21;
    529: MaxSpotNumber:=23;
    625: MaxSpotNumber:=25;
    729: MaxSpotNumber:=27;
    841: MaxSpotNumber:=29;
    961: MaxSpotNumber:=31;
  else
    MaxSpotNumber:=1;
  end;
 }
 MaxSpotNumber:=trunc(Sqrt(StrToFloat(SpotComboBox.Text)));

 for j:=1 to MaxSpotAngle do begin
    for n:=nd to nt do begin
      for k:=1 to MaxSpotArray*MaxSpotArray do begin
        SpotPointY[j,n,k]:=0;
        SpotPointZ[j,n,k]:=0;
      end;
    end;
  end;
end;

procedure TSpotForm.SpinButton1DownClick(Sender: TObject);
begin
  if InputAngleDecimal>=0.1 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     Edit13.text:=FloatToStr(InputAngleDecimal);
     Edit14.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE2.Value+InputAngleDecimal;
  end else begin

  end;
  if InputAngleDecimal<0.1 then  begin
     InputAngleDecimal:=0;
     Edit13.text:=FloatToStr(InputAngleDecimal);
     Edit14.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE2.Value+InputAngleDecimal;
  end;
end;

procedure TSpotForm.SpinButton1UpClick(Sender: TObject);
begin
  if InputAngleDecimal<0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal+0.1;
     Edit13.text:=FloatToStr(InputAngleDecimal);
     Edit14.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE2.value+InputAngleDecimal;
  end else begin

  end;
end;

procedure TSpotForm.SpinButton2DownClick(Sender: TObject);
begin
  if InputAngleDecimal>=0.1 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     Edit14.text:=FloatToStr(InputAngleDecimal);
     Edit13.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE.Value+InputAngleDecimal;
  end else begin

  end;
  if InputAngleDecimal<0.1 then  begin
     InputAngleDecimal:=0;
     Edit14.text:=FloatToStr(InputAngleDecimal);
     Edit13.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE2.Value+InputAngleDecimal;
  end;
end;

procedure TSpotForm.SpinButton2UpClick(Sender: TObject);
begin
  if InputAngleDecimal<0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal+0.1;
     Edit14.text:=FloatToStr(InputAngleDecimal);
     Edit13.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=InputAngleSE.Value+InputAngleDecimal;
  end else begin

  end;
end;

{
procedure TSpotForm.PaintBox3Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;
end;

procedure TSpotForm.PaintBox2Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox1Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox4Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox5Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox6Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox7Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox8Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;

procedure TSpotForm.PaintBox9Paint(Sender: TObject);
begin
  try
    DrawButton2Click(Sender);
  except
    exit;
  end;

end;
}

procedure TSpotForm.PBReDrawControlerPaint(Sender: TObject);
begin
try
//  DrawButtonClick(Sender);
except
  exit;
end;
end;

procedure TSpotForm.PBReDrawControler2Paint(Sender: TObject);
begin
  try
//    DrawButton2Click(Sender); PaintBox͎gȂB
  except
   exit;
  end;
end;

procedure TSpotForm.PaintBox10Paint(Sender: TObject);
begin
try
//  DrawButton3Click(Sender);
except
  exit;
end;
end;

procedure TSpotForm.FormCreate(Sender: TObject);
begin
  Initialize(Sender);
end;

procedure TSpotForm.ScaleEdit2Change(Sender: TObject);
begin
  try
    GraphScale:=StrToFloat(ScaleEdit2.Text);
    self.DrawCompositSpotOnImage;
  except
    on EConvertError do exit ;
    on EInvalidOp do exit;
    on EZeroDivide do exit;
  end;
end;

procedure TSpotForm.BitBtn1Click(Sender: TObject);
var inputString:ShortString;
begin
  inputString:=InputBox('FocusPlaneDistanceInput','œ_ʈʒúH',FloatToStr(OpticalSystem.FocusPlaneDistance) );
  OpticalSystem.FocusPlaneDistance:=StrToFloat(inputString);
  Edit15.Text:=FloatToStr(OpticalSystem.FocusPlaneDistance);
  self.SpotButton2.Click;
end;

procedure TSpotForm.BitBtn2Click(Sender: TObject);
var inputString:ShortString;
begin
  inputString:=InputBox('FocusPlaneDistanceInput','XP[́H',FloatToStr(GraphScale) );
  GraphScale:=StrToFloat(inputString);
  self.DrawCompositSpotOnImage;
  ScaleEdit2.Text:=FloatToStr(GraphScale);
end;

procedure TSpotForm.CulculateMTF;

var
    aDr,  aStep, aDxi,aDyi, aDzi:extended;
    anAngle: array[1..MaxMTFAngle] of Extended;
    aRay:TD3Ray;
    n:TSpectru;
    j,k:integer;
    aStack: boolean;
    aStartTime, aEndTime, aCulTime: TDateTime;
    Au,Bu,Su:extended;
    aPrincipalRay:integer;
    test:integer;

    aHexStr:string;
begin

if OpticalSystem.ObjectDistance>-1.0e10 then begin
    Application.MessageBox('_LłAL_̃y[WŌvZĂB', '', MB_OK);
end else begin



  aStack:=true;

  Screen.Cursor:=crHourGlass;

  aRay:=TD3Ray.create;



try

  if OpticalSystem.EffectiveAperture<>0 then
    aDr:=OpticalSystem.EffectiveAperture
  else
    aDr:=(OpticalSystem.OpticalSurface[1].diameter);

  aStep:=aDr / (MaxSpotNumber - 1);


  for j:=1 to MaxMTFAngle do begin
   anAngle[j]:=degreeToRadian(-1*InputAngle/(MaxMTFAngle-1) * (j-1));

      aDxi:= 1/( sqrt( 1+(tan(anAngle[j])*tan(anAngle[j])) ) )  ;
      aDyi:= -1*aDxi*tan(anAngle[j]) ;
      aDzi:=0;

    for n:=nd to OpticalSystem.LastSpectru do begin
      for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin
        aRay.initialize;
        aRay.qntp:=OpticalSystem.EntrancePupil;  {entrancePupil.}
        aRay.ax:=0;
        aRay.ay:=( (aDr / -2) + ( aStep * int((k - 1) div MaxSpotNumber) )  );
        aRay.az:=( (aDr / -2) + ( aStep * int((k - 1) mod MaxSpotNumber) )  );
        aRay.dxi:=aDxi;
        aRay.dyi:=aDyi;
        aRay.dzi:=aDzi;

        if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
          aStack:=OpticalSystem.RayCheckSwitch;
          OpticalSystem.RayCheckSwitch:=False;
        end;

        OpticalSystem.CenterBrockSwitch:=True;
        OpticalSystem.RayTraceInAspherical(aRay, n);
        OpticalSystem.CenterBrockSwitch:=False;

        if ( k= (MaxSpotNumber*MaxSpotNumber div 2)+1 ) then begin
          OpticalSystem.RayCheckSwitch:=aStack;
        end;

        MTFFinalSurfaceAX[j,n,k]:=aRay.ax;
        MTFFinalSurfaceAY[j,n,k]:=aRay.ay;
        MTFFinalSurfaceAZ[j,n,k]:=aRay.az;
        MTFFinalSurfaceDIX[j,n,k]:=aRay.Dxi;
        MTFFinalSurfaceDIY[j,n,k]:=aRay.Dyi;
        MTFFinalSurfaceDIZ[j,n,k]:=aRay.Dzi;

      end;
    end;
  end;

  self.finalPointForMTFCulculate;

  aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

  for j:=1 to MaxMTFAngle do begin
    Au:=0;
    Bu:=0;
    Su:=0;
    for n:=nd to OpticalSystem.LastSpectru do begin
      for k:=1 to(MaxSpotNumber*MaxSpotNumber) do begin
       if MTFSpotPointY[j,n,k]<>NUll then begin
        Au:=Au+( cos(2*pi*V10*(MTFSpotPointY[j,nd,aPrincipalRay]-MTFSpotPointY[j,n,k]) ) );
        Bu:=Bu+( sin(2*pi*V10*(MTFSpotPointY[j,nd,aPrincipalRay]-MTFSpotPointY[j,n,k]) ) );

        Su:=Su+( cos(2*pi*V10*(MTFSpotPointZ[j,nd,aPrincipalRay]-MTFSpotPointZ[j,n,k]) ) );
       end;
      end;
    end;
     Rt10[j]:=( sqrt((Au*Au)+(Bu*Bu))  )/RayCounter[j];
     Rs10[j]:=Su/RayCounter[j];
  end;


  for j:=1 to MaxMTFAngle do begin
    Au:=0;
    Bu:=0;
    Su:=0;
    for n:=nd to OpticalSystem.LastSpectru do begin
      for k:=1 to(MaxSpotNumber*MaxSpotNumber) do begin
        if MTFSpotPointY[j,n,k]<>NUll then begin
         Au:=Au+( cos(2*pi*V30*(MTFSpotPointY[j,nd,aPrincipalRay]-MTFSpotPointY[j,n,k]) ) );
         Bu:=Bu+( sin(2*pi*V30*(MTFSpotPointY[j,nd,aPrincipalRay]-MTFSpotPointY[j,n,k]) ) );
         Su:=Su+( cos(2*pi*V30*(MTFSpotPointZ[j,nd,aPrincipalRay]-MTFSpotPointZ[j,n,k]) ) );
         Rt30[j]:=( sqrt((Au*Au)+(Bu*Bu))  )/RayCounter[j];
         Rs30[j]:=Su/RayCounter[j];
        end;
      end;
    end;


  end;


finally
  aRay.Free;
  Screen.Cursor:=crDefault;
end;



end;

end;


procedure TSpotForm.finalPointForMTFCulculate;

var
    n:TSpectru;
    j,k:integer;
    aFinalRay:TD3Ray;

begin

aFinalRay:=TD3Ray.Create;

try

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
  FinalOpt.EntrancePupil:=(OpticalSystem.FocusPlaneDistance{BackFocus[nd]} + defocus)*-1;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


  for j:=1 to MaxMTFAngle do begin
    RayCounter[j]:=0;
    for n:=nd to OpticalSystem.LastSpectru do begin


      for k:=1 to (MaxSpotNumber*MaxSpotNumber) do begin

        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=MTFFinalSurfaceAX[j,n,k];
        aFinalRay.ay:=MTFFinalSurfaceAY[j,n,k];
        aFinalRay.az:=MTFFinalSurfaceAZ[j,n,k];
        aFinalRay.dxi:=MTFFinalSurfaceDIX[j,n,k];
        aFinalRay.dyi:=MTFFinalSurfaceDIY[j,n,k];
        aFinalRay.dzi:=MTFFinalSurfaceDIZ[j,n,k];

        if aFinalRay.ay<>NULL then begin
          FinalOpt.RayTraceInAspherical(aFinalRay ,n);
          MTFSpotPointY[j,n,k]:=aFinalRay.ay;
          MTFSpotPointZ[j,n,k]:=aFinalRay.az;
        end else begin
          MTFSpotPointY[j,n,k]:=NULL;
          MTFSpotPointZ[j,n,k]:=NULL;
        end;

        if MTFSpotPointY[j,n,k]<>NULL then begin

           RayCounter[j]:=RayCounter[j]+1;

        end;

      end;
    end;

  end;
finally
  aFinalRay.Free;
end;
end;


procedure TSpotForm.Button5Click(Sender: TObject);
begin

   MTFform.visible:=true;
   MTFform.Show;
   MTFform.Button2Click(Sender);

end;



procedure TSpotForm.PageControl1Change(Sender: TObject);
begin
 if PageControl1.ActivePage=TabSheet1 then begin
   DefocusScrollBar.Position:=DefocusScrollBar2.Position;
   DefocusEdit.Text:=DefocusEdit2.Text;
   self.DrawSeparatSpot;
 end;

end;

procedure TSpotForm.DrawCompositSpotOnImage;
var
  n:TSpectru;
  aCenterX, aCenterY,aDodPointX,aDodPointY:longInt;
  k:integer;
  aDodScale:extended;
  aPrincipalRay:integer;
  aSpotImage:TImage;
  aSpace:word;
  j:integer;
  aNowDodColor:TColor;
  aDrawnDodColor:TColor;
  aPenColorBuckUp:TColor;
  aDrawPenColor:Tcolor;
begin

  if OpticalSystem.ObjectDistance>-1.0e10 then
    exit;


  for j:=1 to MaxSpotAngle do begin


    case j of

       1 : aSpotImage:=Image1;
       2 : aSpotImage:=Image2;
       3 : aSpotImage:=Image3;
       4 : aSpotImage:=Image4;
       5 : aSpotImage:=Image5;
       6 : aSpotImage:=Image6;
       7 : aSpotImage:=Image7;
       8 : aSpotImage:=Image8;
       9 : aSpotImage:=Image9;

    end;

    aSpotImage.Canvas.brush.Color:=clGray;
    aSpotImage.Picture.Bitmap.Canvas.fillRect(aSpotImage.Canvas.clipRect) ;


    aSpace:=2;
    aDodScale:=GraphScale/ (aSpotImage.width - aSpace*2);
    aCenterX:=aSpotImage.width div 2;
    aCenterY:=aSpotImage.height div 2;
    aPrincipalRay:=sqr(MaxSpotNumber) div 2 + 1;

    aSpotImage.Picture.Bitmap.Canvas.Pen.Color:=clBlack;
    aSpotImage.Picture.Bitmap.Canvas.Rectangle(0,0,aSpotImage.width,aSpotImage.height);
    aSpotImage.Picture.Bitmap.Canvas.Pen.Color:=clSilver;
    aSpotImage.Picture.Bitmap.Canvas.MoveTo( aSpotImage.width div 2, aSpace );
    aSpotImage.Picture.Bitmap.Canvas.LineTo( aSpotImage.width div 2, aSpotImage.height-aSpace  );
    aSpotImage.Picture.Bitmap.Canvas.MoveTo( aSpace, aSpotImage.height div 2 );
    aSpotImage.Picture.Bitmap.Canvas.LineTo( aSpotImage.width-aSpace, aSpotImage.height div 2  );

    for n:=nd to OpticalSystem.LastSpectru do begin
     case n of
       nt : aSpotImage.Canvas.Pen.Color:=clNt;
       ns : aSpotImage.Canvas.Pen.Color:=clNs;
       nr : aSpotImage.Canvas.Pen.Color:=clNr;
       nC : aSpotImage.Canvas.Pen.Color:=clNC;
       nd : aSpotImage.Canvas.Pen.Color:=clNd;
       ne : aSpotImage.Canvas.Pen.Color:=clNe;
       nF : aSpotImage.Canvas.Pen.Color:=clNF;
       ng : aSpotImage.Canvas.Pen.Color:=clNg;
       nh : aSpotImage.Canvas.Pen.Color:=clNh;
       ni : aSpotImage.Canvas.Pen.Color:=clNi;
     end;

     for k:=1 to MaxSpotNumber*MaxSpotNumber do begin
       if SpotPointY[j,n,k]<>NULL then begin
         aDodPointX:=aCenterX -trunc((SpotPointZ[j,nd,aPrincipalRay] - SpotPointZ[j,n,k]) / aDodScale);
         aDodPointY:=aCenterY +trunc((SpotPointY[j,nd,aPrincipalRay] - SpotPointY[j,n,k]) / aDodScale);

         aNowDodColor:=aSpotImage.Picture.Bitmap.Canvas.Pixels[aDodPointX,aDodPointY];
         aPenColorBuckUp:=aSpotImage.Canvas.Pen.Color;
         if aNowDodColor=clGray then begin

         end else begin
           aSpotImage.Canvas.Pen.Color:=aNowDodColor or aSpotImage.Canvas.Pen.Color;
         end;

         aSpotImage.Canvas.MoveTo(aDodPointX,aDodPointY);
         aSpotImage.Canvas.LineTo( (aDodPointX+1),(aDodPointY+1) );
         aSpotImage.Canvas.Pen.Color:=aPenColorBuckUp;


       end;
     end;

    end;

  end;


  Edit1.Text:=floatToStrF(SpotPointY[2,nd,aPrincipalRay],ffGeneral,5,4);
  Edit2.Text:=floatToStrF(SpotPointY[3,nd,aPrincipalRay],ffGeneral,5,4);
  Edit8.Text:=floatToStr(InputAngle* (Half) );
  Edit12.Text:=floatToStr(InputAngle* (Full) );

  ImageHight:=SpotPointY[3,nd,aPrincipalRay];
  ImageHightHarf:=SpotPointY[2,nd,aPrincipalRay];

end;





procedure TSpotForm.Button6Click(Sender: TObject);
begin
  self.DrawCompositSpotOnImage;
end;

procedure TSpotForm.Button7Click(Sender: TObject);
begin
 SPCForm.Visible:=True;
end;

end.

