unit StrGrdIO;

// ĂƁAjbgł͂炪LɂȂ悤
{$RANGECHECKS OFF}

// StringGrid̃f[^]R|[lg
// susumuk@fa.mbn.or.jp
// http://www14.big.or.jp/~kawamura/
//
// ōĔzz͎RłB
// 7/10/98 ver 0.1 }ɎvčB
// 9/22/98 ver 0.2 CSV`ɑΉB
// 7/3/2002 ver 0.3
//    f[^TCYɍ킹ColCount/RowCountLk\ɂB
//    Lk\łȂꍇ́AŏI̓͂̎d펯Iȕ@ɂB
//    Clear\bhB

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, Clipbrd, ComObj;

type
  TStringGridIO = class(TComponent)
  private
    TheGrid:TStringGrid;
    fStretch : boolean;
  public
    // Excel97ɓ]BExcel95ł͈ꕔΓ͂
    // ĂȂ̂ŊmFłȂB
    procedure SendToExcel;
    // TextfileɕۑB؂蕶delimŎw肷B
    // ""ň݂͂Ƃ́ACSV=Trueɂ邱ƁB
    procedure SaveToFile(filename,delim:string;CSV:boolean);
    // HTML\ŕۑB
    procedure SaveToHTML(filename:string);
    // TextfileǂݍށB؂蕶delimŎwB
    // ""ň͂܂ꂽ𕶎ƔFƂ́ACSV=Trueɂ邱ƁB
    procedure LoadFromFile(filename,delim:string;CSV:boolean);
    // Nbv{[hɃRs[B؂蕶delimŎwB
    procedure CopyToClipboard(delim:string);
    // Nbv{[h\B؂蕶delimŎwB
    procedure PasteFromClipboard(delim:string);
    // \NAB
    procedure Clear;

    constructor Create(AOwner:TComponent);override ;

  published
    // ΏۂƂȂStringGridR|[lg
    property TargetGrid : TStringGrid read TheGrid write TheGrid;
    property Stretch : boolean read fStretch write fStretch;
  end;

procedure Register;

implementation

constructor TStringGridIO.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
end;

// Excel97NAf[^]
procedure TStringGridIO.SendToExcel;
var Excel,Application,Workbook:Variant;
    i,j:integer;
begin
  if Assigned(TheGrid) then
  begin
     Excel := CreateOleObject('Excel.Application');
     Application :=  Excel.Application;
     Application.Visible := True;
     Application.ScreenUpdating:=false;
     try
        WorkBook := Application.WorkBooks.Add;
        WorkBook.WorkSheets[1].Activate;
        for i:=0 to TheGrid.RowCount-1 do
            for j:=0 to TheGrid.ColCount-1 do
                WorkBook.ActiveSheet.Cells[i+1,j+1].Value:=TheGrid.Cells[j,i];
     finally
        Application.ScreenUpdating:=true;
     end;
  end;
end;

// StringGrid̒geLXgt@Cŕۑ
procedure TStringGridIO.SaveToFile(filename,delim:string;CSV:boolean);
var i,j:integer;
    s:string;
    StringList:TStringList;

function InsertWQuote(CSV:boolean;s:string):string;
var Code:integer;
    a:double;
begin
     Result := s;
     if CSV then
     begin
          // {$R-}łȂ΂ȂȂB
          Val(s,a,Code);
          if code <> 0 then Result := '"' + s + '"';
     end;
end;

begin
  if Assigned(TheGrid) then
  begin
     StringList := TStringList.Create;
     try
        for i:=0 to TheGrid.RowCount-1 do
        begin
             s:=InsertWQuote(CSV,TheGrid.Cells[0,i]);
             for j:=1 to TheGrid.ColCount-1 do
             begin
                 s:=s+delim+InsertWQuote(CSV,TheGrid.Cells[j,i]);
             end;
             StringList.Add(s);
        end;
        StringList.SaveToFile(filename);
     finally
        StringList.Free;
     end;
  end;
end;

// StringGrid̒gHTMLŕۑ
procedure TStringGridIO.SaveToHTML(filename:string);
var i,j:integer;
    StringList:TStringList;
    s:string;
begin
  if Assigned(TheGrid) then
  begin
     StringList:=TStringList.Create;
     try
        StringList.Add('<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML i18n//EN">');
        StringList.Add('<HTML>');
        StringList.Add('<HEAD>');
        StringList.Add('<TITLE>'+filename+'</TITLE>');
        StringList.Add('<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=Shift_JIS">');
        StringList.Add('</HEAD>');
        StringList.Add('<BODY>');
        StringList.Add('');
        StringList.Add('<TABLE BORDER>');
        for i:=0 to TheGrid.RowCount-1 do
        begin
           s:='<TR>';
           for j:=0 to TheGrid.ColCount-1 do
                s:=s+'<TD>'+TheGrid.Cells[j,i]+'</TD>';
           s:=s+'</TR>';
           StringList.Add(s);
        end;
        StringList.Add('</TABLE>');
        StringList.Add('</BODY>');
        StringList.Add('</HTML>');
        StringList.SaveToFile(filename);
     finally
        StringList.Free;
     end;
  end;
end;

// eLXgt@Cǂݍ
procedure TStringGridIO.LoadFromFile(filename,delim:string;CSV:boolean);
var i,j:integer;
    s,temps:string;
    StringList:TStringList;
    colmax, tempcolmax : integer;

function DeleteWQuote(CSV:boolean;s:string):string;
begin
     Result := s;
     if CSV then
     begin
          if Length(s)<2 then exit;
          if (s[1]='"') and (s[Length(s)]='"') then
             Result := Copy(s,2,Length(s)-2);
     end;
end;

begin
  if Assigned(TheGrid) then
  begin
     StringList := TStringList.Create;
     try
        StringList.LoadFromFile(filename);
        if fStretch then
        begin
           Clear;
           TheGrid.RowCount := StringList.Count;
           colmax := 0;
           for i := 0 to StringList.Count - 1 do
           begin
              tempcolmax := 0;
              s := StringList.Strings[i];
              while Pos(delim,s)>0 do
              begin
                 s := Copy(s,Pos(delim,s)+1,Length(s)-Pos(delim,s));
                 inc(tempcolmax);
              end;
              if colmax<tempcolmax then colmax := tempcolmax;
           end;
           TheGrid.ColCount := colmax+1;
        end;
        i:=0;
        while (i<TheGrid.RowCount) and (i<StringList.Count) do
        begin
             s:=StringList.Strings[i];
             temps:=Copy(s,1,Pos(delim,s)-1);
             j:=0;
             // ColCountɂȂ܂ŌJԂ
             while (j<TheGrid.ColCount-1) do
             begin
                  TheGrid.Cells[j,i] := DeleteWQuote(CSV,temps);
                  Delete(s,1,Pos(delim,s));
                  if j<TheGrid.ColCount-2 then
                     temps := Copy(s,1,Pos(delim,s)-1)
                  else temps:=s;
                  j:=j+1;
             end;
             TheGrid.Cells[j,i]:=DeleteWQuote(CSV,temps);
             i:=i+1;
        end;
     finally
        StringList.Free;
     end;
  end;
end;

// StringGrid̒gNbv{[hɃRs[
procedure TStringGridIO.CopyToClipboard(delim:string);
var i,j:integer;
    s:string;
begin
  if Assigned(TheGrid) then
  begin
     s:='';
     for i:=0 to TheGrid.RowCount-1 do
     begin
          s:=s+TheGrid.Cells[0,i];
          for j:=1 to TheGrid.ColCount-1 do
              s:=s+delim+TheGrid.Cells[j,i];
          s:=s+#13+#10;
     end;
     ClipBoard.Open;
     try
        Clipboard.AsText := s;
     finally
        Clipboard.Close;
     end;
  end;
end;

// StringGrid̒gNbv{[h\t
procedure TStringGridIO.PasteFromClipboard(delim:string);
var i,j:integer;
    s,temps,temps2:string;
    MyHandle: THandle;
    TextPtr: PChar;
    StringList : TStringList;
    colmax, tempcolmax : integer;
begin
  if Assigned(TheGrid) then
  begin
     ClipBoard.Open;
     try
        MyHandle := Clipboard.GetAsHandle(CF_TEXT);
        TextPtr := GlobalLock(MyHandle);
        s := TextPtr;
        GlobalUnlock(MyHandle);
     finally
        Clipboard.Close;
     end;
     StringList := TStringList.Create;
     try
        StringList.Text := s;
        if fStretch then
        begin
           Clear;
           TheGrid.RowCount := StringList.Count;
           colmax := 0;
           for i := 0 to StringList.Count - 1 do
           begin
              tempcolmax := 0;
              s := StringList.Strings[i];
              while Pos(delim,s)>0 do
              begin
                 s := Copy(s,Pos(delim,s)+1,Length(s)-Pos(delim,s));
                 inc(tempcolmax);
              end;
              if colmax<tempcolmax then colmax := tempcolmax;
           end;
           TheGrid.ColCount := colmax+1;
        end;
        for i:=0 to TheGrid.RowCount-1 do
        begin
           // sǂݏo
           temps:=StringList.Strings[i];
           temps2:=Copy(temps,1,Pos(delim,temps)-1);
           j:=0;
           // ColCountɂȂ܂ŌJԂ
           while (j<TheGrid.ColCount-1) do
           begin
               TheGrid.Cells[j,i] := temps2;
               Delete(temps,1,Pos(delim,temps));
               if j<TheGrid.ColCount-2 then
                  temps2 := Copy(temps,1,Pos(delim,temps)-1)
               else temps2:=temps;
               j:=j+1;
           end;
           TheGrid.Cells[TheGrid.ColCount-1,i] := temps2;
        end;
     finally
        StringList.Free;
     end;
  end;
end;

// Z
procedure TStringGridIO.Clear;
var i:integer;
begin
  if Assigned(TheGrid) then
  begin
     for i:=0 to TheGrid.RowCount-1 do
         TheGrid.Rows[i].Clear;
  end;
end;

procedure Register;
begin
  RegisterComponents('Additional', [TStringGridIO]);
end;

end.
